<?php
/*
Plugin Name: ARForms
Description: Exclusive Wordpress Form Builder Plugin With Seven Most Popular E-Mail Marketing Tools Integration
Version: 2.5.4
Plugin URI: http://www.arformsplugin.com/
Author: Repute InfoSystems
Author URI: http://reputeinfosystems.com/
Text Domain: ARForms
*/

class arfieldhelper{


    function arfieldhelper(){

        add_filter('arfgetdefaultvalue', array(&$this, 'get_default_value'), 10, 3);

		add_filter('arfreplaceshortcodes', array(&$this, 'replace_html_shortcodes'), 10, 2);

        add_filter('arfsetupeditfieldsvars', array(&$this, 'setup_edit_vars'), 10, 3);

        add_filter('arfgetpagedfields', array(&$this, 'get_form_fields'), 10, 3);

        add_filter('arfothercustomhtml', array(&$this, 'get_default_html'), 10, 2);

        add_filter('arfsetupeditfieldvars', array(&$this, 'setup_new_field_vars'), 10);

        add_filter('arfsetupnewfieldsvars', array(&$this, 'setup_new_vars'), 10, 2);

        add_filter('arfbeforereplaceshortcodes', array(&$this, 'before_replace_shortcodes'), 10, 4);

        add_filter('arfpostedfieldids', array(&$this, 'posted_field_ids'));

    }


    


    function get_default_value($value, $field, $dynamic_default=true, $return_array=false){


        if (is_array(maybe_unserialize($value))) return $value;


        if($field and $dynamic_default){


            $field->field_options = maybe_unserialize($field->field_options);


            if(isset($field->field_options['dyn_default_value']) and !empty($field->field_options['dyn_default_value'])){


                $prev_val = $value;


                $value = $field->field_options['dyn_default_value'];


            }


        }



        preg_match_all( "/\[(date|time|email|login|display_name|first_name|last_name|user_meta|post_meta|post_id|post_title|post_author_email|ip_address|auto_id|get|get-(.?)|\d*)\b(.*?)(?:(\/))?\]/s", $value, $matches, PREG_PATTERN_ORDER);



        if (!isset($matches[0])) return $value;


        foreach ($matches[0] as $match_key => $val){


            switch($val){


                case '[date]':


                    global $style_settings;


                    $new_value = date_i18n($style_settings->date_format, strtotime(current_time('mysql')));


                    break;


                case '[time]':


                    $new_value = date('H:i:s', strtotime(current_time('mysql')));


                    break;


                case '[email]':


                    global $current_user;


                    $new_value = (isset($current_user->user_email)) ? $current_user->user_email : '';


                    break;


                case '[login]':


                    global $current_user;


                    $new_value = (isset($current_user->user_login)) ? $current_user->user_login : '';


                    break;


                case '[display_name]':


                    global $current_user;


                    $new_value = (isset($current_user->display_name)) ? $current_user->display_name : '';


                    break;


                case '[first_name]':


                    global $current_user;


                    $new_value = (isset($current_user->user_firstname)) ? $current_user->user_firstname : '';


                    break;


                case '[last_name]':


                    global $current_user;


                    $new_value = (isset($current_user->user_lastname)) ? $current_user->user_lastname : '';


                    break;


                case '[post_id]':


                    global $post;


                    if($post)


                        $new_value = $post->ID;


                    break;


                case '[post_title]':


                    global $post;


                    if($post)


                        $new_value = $post->post_title;


                    break;


                case '[post_author_email]':


                    $new_value = get_the_author_meta('user_email');


                    break;


                case '[user_id]':


                    global $user_ID;


                    $new_value = $user_ID ? $user_ID : '';


                    break;


                case '[ip_address]':


                    $new_value = $_SERVER['REMOTE_ADDR'];


                    break;


                default:


                    $atts = shortcode_parse_atts(stripslashes($matches[3][$match_key]));


                    $shortcode = $matches[1][$match_key];


                    


                    if (preg_match("/\[get-(.?)\b(.*?)?\]/s", $val)){


                        $param = str_replace('[get-', '', $val);


                        if (preg_match("/\[/s", $param))


                            $val .= ']';


                        else


                            $param = trim($param, ']'); 


                        $new_value = armainhelper::get_param($param);


                        if(is_array($new_value) and !$return_array)


                            $new_value = implode(', ', $new_value);


                    }else{


                        switch($shortcode){


                            case 'get':


                                $new_value = '';


                                if(isset($atts['param'])){


                                    if(strpos($atts['param'], '&#91;')){


                                        $atts['param'] = str_replace('&#91;', '[', $atts['param']);


                                        $atts['param'] = str_replace('&#93;', ']', $atts['param']);


                                    }


                                    $new_value = armainhelper::get_param($atts['param'], false);


                                    if(!$new_value){


                                        global $wp_query;


                                        if(isset($wp_query->query_vars[$atts['param']]))


                                            $new_value = $wp_query->query_vars[$atts['param']];


                                    } 


                                    if(!$new_value and isset($atts['default']))


                                        $new_value = $atts['default'];


                                    else if(!$new_value and isset($prev_val))


                                        $new_value = $prev_val;


                                }





                                if(is_array($new_value) and !$return_array)


                                    $new_value = implode(', ', $new_value);


                            break;


                            case'auto_id':


                                global $arfrecordmeta;





                                $last_entry = $arfrecordmeta->get_max($field);





                                if(!$last_entry and isset($atts['start']))


                                    $new_value = (int)$atts['start'];





                                if (!isset($new_value)) $new_value = $last_entry + 1;


                            break;


                            case 'user_meta':


                                if(isset($atts['key'])){


                                    global $current_user;


                                    $new_value = (isset($current_user->{$atts['key']})) ? $current_user->{$atts['key']} : '';


                                }


                            break;


                            case 'post_meta':


                                if(isset($atts['key'])){


                                    global $post;


                                    if($post){


                                        $post_meta = get_post_meta($post->ID, $atts['key'], true);


                                        if($post_meta)


                                            $new_value = $post_meta;


                                    }


                                }


                            break;


                            default:


                                if(is_numeric($shortcode)){ 


                                    $new_value = armainhelper::get_param('item_meta['. $shortcode .']', false);





                                    if(!$new_value and isset($atts['default']))


                                        $new_value = $atts['default'];





                                    if(is_array($new_value) and !$return_array)


                                        $new_value = implode(', ', $new_value);


                                }else{


                                    $new_value = $val;


                                }


                            break;


                        }


                    }


            }


            if (!isset($new_value)) $new_value = '';


            


            if(is_array($new_value))


                $value = $new_value;


            else


                $value = str_replace($val, $new_value, $value);


            unset($new_value);


        }


        return do_shortcode($value);


    }


    


    function setup_new_field_vars($values){


        $values['field_options'] = maybe_unserialize($values['field_options']);


        foreach (arfieldhelper::get_default_field_opts($values) as $opt => $default)


            $values[$opt] = (isset($values['field_options'][$opt])) ? $values['field_options'][$opt] : $default;


        return $values;


    }


    function setup_new_vars($values, $field){


        $values['use_key'] = false;


        $field->field_options = maybe_unserialize($field->field_options);


        foreach ($this->get_default_field_opts($values, $field) as $opt => $default)


            $values[$opt] = (isset($field->field_options[$opt]) && $field->field_options[$opt] != '') ? $field->field_options[$opt] : $default;


        $values['hide_field'] = (array)$values['hide_field'];    


        $values['hide_field_cond'] = (array)$values['hide_field_cond'];


        $values['hide_opt'] = (array)$values['hide_opt'];


        if ($values['type'] == 'date'){


            if (preg_match('/^\d{4}-\d{2}-\d{2}$/', $values['value'])){ 


                global $style_settings;


                $values['value'] = armainhelper::convert_date($values['value'], 'Y-m-d', $style_settings->date_format);


            }


        }else if(!empty($values['options'])){


            foreach($values['options'] as $val_key => $val_opt){


                if(is_array($val_opt)){


                    foreach($val_opt as $opt_key => $opt){


                        $values['options'][$val_key][$opt_key] = $this->get_default_value($opt, $field, false);


                        unset($opt_key);


                        unset($opt);


                    }


                }else{


                   $values['options'][$val_key] = $this->get_default_value($val_opt, $field, false);


                }


                unset($val_key);


                unset($val_opt);


            }


        }

        if(is_array($values['value'])){


            foreach($values['value'] as $val_key => $val)


                $values['value'][$val_key] = apply_filters('arfgetdefaultvalue', $val, $field);


        }else if(!empty($values['value'])){


            $values['value'] = apply_filters('arfgetdefaultvalue', $values['value'], $field);


        }

        return $values;


    }

	
	function field_selection(){


        $fields = apply_filters('arfavailablefields', array(


            'text' => __('Single Line Text', 'ARForms'),


            'textarea' => __('Multiline Text', 'ARForms'),


            'checkbox' => __('Checkboxes', 'ARForms'),


            'radio' => __('Radio Buttons', 'ARForms'),


            'select' => __('Dropdown', 'ARForms'),


			'file' => __('File Upload', 'ARForms'),

		
        ));


        


        return $fields;


    }
	
	function get_all_form_fields($form_id, $error=false){


        global $arffield;


        $fields = apply_filters('arfgetpagedfields', false, $form_id, $error);


        if (!$fields)


            $fields = $arffield->getAll(array('fi.form_id' => $form_id), 'field_order');


        return $fields;


    }
	
	function pro_field_selection(){


        return apply_filters('arfaavailablefields', array(

			'email' => __('Email Address', 'ARForms'),
			
			'captcha' => __('CAPTCHA', 'ARForms'),

            'number' => __('Number', 'ARForms'), 

            'phone' => __('Phone Number', 'ARForms'), 

            'date' => __('Date', 'ARForms'), 

            'time' => __('Time', 'ARForms'),
			
			'url' => __('Website/URL', 'ARForms'),

            'image' => __('Image URL', 'ARForms'), 

            'hidden' => __('Hidden Field', 'ARForms'), 

            'password'  => __('Password', 'ARForms'),

            'html' => __('HTML', 'ARForms'),

            'divider' => __('Section', 'ARForms'),
			
			'break' => __('Page Break', 'ARForms'),					
			
			'scale' => __('Star Rating', 'ARForms'),
			
			'like' => __('Like button', 'ARForms'), 
			
			'slider' => __('Slider', 'ARForms'), 
        ));


    }
        


    function setup_edit_vars($values, $field, $entry_id=false){


        $values['use_key'] = false;

        $field->field_options = maybe_unserialize($field->field_options);

		$values['option_order'] = maybe_unserialize($field->option_order);
		
        foreach ($this->get_default_field_opts($values, $field) as $opt => $default){


            $values[$opt] = stripslashes_deep(($_POST and isset($_POST['field_options'][$opt.'_'.$field->id]) ) ? $_POST['field_options'][$opt.'_'.$field->id] : (isset($field->field_options[$opt]) ? $field->field_options[$opt]: $default));


        }


        $values['hide_field'] = (array)$values['hide_field'];    


        $values['hide_field_cond'] = (array)$values['hide_field_cond'];


        $values['hide_opt'] = (array)$values['hide_opt'];


		if ($values['type'] == 'date'){


            global $style_settings;


            if (preg_match('/^\d{4}-\d{2}-\d{2}$/', $values['value']))


                $values['value'] = armainhelper::convert_date($values['value'], 'Y-m-d', $style_settings->date_format);


            else if (preg_match('/^\d{4}-\d{2}-\d{2}/', $values['value']))


                $values['value'] = armainhelper::convert_date($values['value'], 'Y-m-d H:i:s', $style_settings->date_format);


        }else if ($values['type'] == 'file'){

           
            if($values['post_field'] != 'post_custom'){


                global $arfrecordmeta;


                $values['value'] = $arfrecordmeta->get_entry_meta_by_field($entry_id, $values['id']);


            }


        }
        return $values;

    }


    function get_default_field_opts($values=false, $field=false){


        global $style_settings;


        $minnum = 1;


        $maxnum = 10;


        $step = 1;


        $align = 'block';


        if($values){


            if($values['type'] == 'number'){


                $minnum = 0;


                $maxnum = 9999;


            }else if ($values['type'] == 'time'){


                $step = 30;


            }else if($values['type'] == 'radio'){


                $align = 'inline';//$style_settings->arfradioalignsetting;


            }else if($values['type'] == 'checkbox'){


                $align = 'block'; //$style_settings->arfcheckboxalignsetting;


            }else if($values['type'] == 'scale'){


                $maxnum = 5; 


            }


        }
		
		if( $values['type'] == 'slider' ){
			$minnum = 0;
			$maxnum = 50; 
		}

        $end_minute = 60 - (int)$step;


        unset($values);


        unset($field);


        return array(


            'slide' => 0, 'form_select' => '', 'show_hide' => 'show', 'any_all' => 'any', 'align' => $align,


            'hide_field' => array(), 'hide_field_cond' =>  array('=='), 'hide_opt' => array(), 'star' => 0,


            'post_field' => '', 'custom_field' => '', 'taxonomy' => 'category', 'exclude_cat' => 0, 'ftypes' => array(),


            'data_type' => '', 'restrict' => 0, 'start_year' => 2000, 'end_year' => 2020, 'read_only' => 0, 


            'locale' => '', 'attach' => false, 'minnum' => $minnum, 'maxnum' => $maxnum, 


            'step' => $step, 'clock' => 12, 'start_time' => '00:00', 'end_time' => '23:'.$end_minute, 


            'dependent_fields' => 0, 'use_calc' => 0, 'calc' => '', 'duplication' => 1,


            'dyn_default_value' => '', 'field_width' => '', 'label_width' => $style_settings->width, 
			
			
			'text_direction' => $style_settings->text_direction, 'align_radio' => '1', 'custom_width_field'=> '0',	


        );


    }


    


    function check_data_values($values){


        $check = true;

        return $check;


    }
	
	function setup_new_variables($type='', $form_id=''){


        global $arfsettings;


        


        $defaults = arfieldhelper::get_default_field_options($type, $form_id);


        $defaults['field_options']['custom_html'] = arfieldhelper::get_basic_default_html($type);





        $values = array();


        


        foreach ($defaults as $var => $default){


            if($var == 'field_options'){


                $values['field_options'] = array();


                foreach ($default as $opt_var => $opt_default){


                    $values['field_options'][$opt_var] = $opt_default;


                    unset($opt_var);


                    unset($opt_default);


                }


            }else{


                $values[$var] = $default;


            }


            unset($var);


            unset($default);


        }


            


        if ($type == 'checkbox')


            $values['options'] = maybe_serialize(array(__('Checkbox 1', 'ARForms'), __('Checkbox 2', 'ARForms')));
			
			
		else if ($type == 'radio')

			
			$values['options'] = maybe_serialize(array(__('Radio 1', 'ARForms'), __('Radio 2', 'ARForms')));
			

        else if ( $type == 'select')


            $values['options'] = maybe_serialize(array('', __('Select 1', 'ARForms')));


        else if ($type == 'textarea')


            $values['field_options']['max'] = '3';


        else if ($type == 'captcha')


            $values['invalid'] = $arfsettings->re_msg;


        


        return $values;


    }
	
	function setup_edit_variables($record){


        global $arfrecordmeta, $arfform;



        $values = array('id' => $record->id, 'form_id' => $record->form_id , 'conditional_logic' => maybe_unserialize($record->conditional_logic), 'option_order ' => maybe_unserialize($record->option_order )  ); //---------- for conditional logic ----------//
		
		
		
		foreach (array('name' => $record->name, 'description' => $record->description) as $var => $default)	
            $values[$var] = $default;
				
        $values['form_name'] = ($record->form_id) ? $arfform->getName( $record->form_id ) : '';


        


        foreach (array('field_key' => $record->field_key, 'type' => $record->type, 'default_value'=> $record->default_value, 'field_order' => $record->field_order, 'required' => $record->required) as $var => $default)


            $values[$var] = armainhelper::get_param($var, $default);


        


        $values['options'] = $record->options;


        $values['field_options'] = $record->field_options;


        


        $defaults = arfieldhelper::get_default_field_options($values['type'], $record, true);


        


        if($values['type'] == 'captcha'){


            global $arfsettings;


            $defaults['invalid'] = $arfsettings->re_msg;


        }


            


        foreach($defaults as $opt => $default)


            $values[$opt] = (isset($record->field_options[$opt])) ? $record->field_options[$opt] : $default; 





        $values['custom_html'] = (isset($record->field_options['custom_html'])) ? $record->field_options['custom_html'] : arfieldhelper::get_basic_default_html($record->type);


        


        return apply_filters('arfsetupeditfieldvars', $values, $values['field_options']);


    }

    function _show_category($atts) {


        extract($atts);


    	if(!is_object($cat)) return;


    	$checked = '';


    	if(is_array($value)) 


    		$checked = (in_array($cat->cat_ID, $value)) ? 'checked="checked" ' : '';


    	else if($cat->cat_ID == $value)


    	    $checked = 'checked="checked" ';


    	else


    	    $checked = '';


    	$class = '';


    	$sanitized_name = ((isset($field['id'])) ? $field['id'] : $field['field_options']['taxonomy']).'-'. $cat->cat_ID;

    	?>


    	<div class="frm_<?php echo $type ?>" id="frm_<?php echo $type .'_'. $sanitized_name ?>">


    	    <label<?php echo $class ?> for="field_<?php echo $sanitized_name ?>"><input type="<?php echo $type ?>" name="<?php echo $field_name ?>" <?php echo (isset($hide_id) and $hide_id)? '' : 'id="field_'. $sanitized_name .'"'; ?> value="<?php echo $cat->cat_ID ?>" <?php echo $checked;  do_action('arffieldinputhtml', $field); ?> /><?php echo $cat->cat_name ?></label>

<?php

    	$children = get_categories(array('type' => $post_type, 'orderby' => 'name', 'order' => 'ASC', 'hide_empty' => false, 'exclude' => $exclude, 'parent' => $cat->cat_ID, 'taxonomy' => $taxonomy));


    	if($children){ 


    	    $level++;


    	    foreach($children as $key => $cat){ ?>


    	<div class="catlevel_<?php echo $level ?>"><?php arfieldhelper::_show_category(compact('cat', 'field', 'field_name', 'exclude', 'type', 'value', 'exclude', 'level', 'onchange', 'post_type', 'taxonomy', 'hide_id')) ?></div>


<?php       }


        }


    	echo '</div>';


    }


    function get_status_options($field){


        $post_type = arformmodel::post_type($field->form_id);


        $post_type_object = get_post_type_object($post_type);


        $options = array();


        if(!$post_type_object)


            return $options;


        $can_publish = current_user_can($post_type_object->cap->publish_posts);


        $options = get_post_statuses(); 



        if(!$can_publish){ 


        	unset($options['publish']);


        	if(isset($options['future']))


        	    unset($options['future']);


        }


        return $options;


    }


    function get_user_options(){


        global $wpdb;


        $users = (function_exists('get_users')) ? get_users(array( 'fields' => array('ID','user_login','display_name'), 'blog_id' => $GLOBALS['blog_id'])) : get_users(array( 'fields' => array('ID','user_login','display_name'), 'blog_id' => $GLOBALS['blog_id']));


        $options = array('' => '');


        foreach($users as $user)


            $options[$user->ID] = (!empty($user->display_name)) ? $user->display_name : $user->user_login;


        return $options;


    }


    function get_linked_options($values, $field, $entry_id=false){


        global $arfrecordmeta, $user_ID, $arffield, $MdlDb;


        $metas = array();


        $selected_field = $arffield->getOne($values['form_select']);


        if(!$selected_field)


            return array();


        $selected_field->field_options = maybe_unserialize($selected_field->field_options);



        $attach_ids = array();


        if ($values['restrict'] and $user_ID){


            $entry_user = $user_ID;


            if($entry_id and is_admin()){


                $entry_user = $MdlDb->get_var($MdlDb->entries, array('id' => $entry_id), 'user_id');


                if(!$entry_user or empty($entry_user))


                    $entry_user = $user_ID;


            }



            if (isset($selected_field->form_id)){


                $linked_where = array('form_id' => $selected_field->form_id, 'user_id' => $entry_user);


               $entry_ids = $MdlDb->get_col($MdlDb->entries, $linked_where, 'id');


                unset($linked_where);


            }


            if (isset($entry_ids) and !empty($entry_ids))


                $metas = $arfrecordmeta->getAll("it.entry_id in (".implode(',', $entry_ids).") and field_id=". (int)$values['form_select'], ' ORDER BY entry_value');


        }else{


            $metas = $MdlDb->get_records($MdlDb->entry_metas, array('field_id' => $values['form_select']), 'entry_value', '', 'entry_id, entry_value');


            $attach_ids = $MdlDb->get_records($MdlDb->entries, array('form_id' => $selected_field->form_id), '', '', 'id, attachment_id');


        }

        $options = array();


        foreach ($metas as $meta){


            $meta = (array)$meta;


            if(empty($meta['entry_value'])) continue;


            if($selected_field->type == 'image')


                $options[$meta['entry_id']] = $meta['entry_value'];


            else


                $options[$meta['entry_id']] = arrecordhelper::display_value($meta['entry_value'], $selected_field, array('type' => $selected_field->type, 'show_icon' => false, 'show_filename' => false));


            unset($meta);


        }


        unset($metas);


        natcasesort($options); 


        


        return $options;


    }


    function posted_field_ids($where){


        if (isset($_POST['form_id']) and isset($_POST['arfpageorder'. $_POST['form_id']]))


            $where .= ' and fi.field_order < '. (int)$_POST['arfpageorder'. $_POST['form_id']];


        return $where;


    }


    function get_form_fields($fields, $form_id, $error=false){


        global $arfprevpage, $arffield, $arfnextpage;


        $prev_page = armainhelper::get_param('arfpageorder'. $form_id, false);


        $prev_page = (int)$prev_page;


        $where = "fi.type='break' AND fi.form_id=". (int)$form_id;


        if ($error and !$prev_page)


            $prev_page = 999;



        if ($prev_page){


            if ($error){


                $where_error = $where . " AND fi.field_order <" . ($prev_page);


                $prev_page_obj = $arffield->getAll($where_error, 'field_order DESC', 1);


                $prev_page = ($prev_page_obj) ? $prev_page_obj->field_order : false;


            }



            if ($prev_page and !isset($prev_page_obj)){


                $prev_where = $where . " AND fi.field_order=". $prev_page;


                $prev_page_obj = $arffield->getAll($prev_where, 'field_order DESC', 1);


            }


            $arfprevpage[$form_id] = $prev_page;


            $where .= ' AND fi.field_order >='. ($prev_page + 1);


        }else


            unset($arfprevpage[$form_id]);


        $next_page = $arffield->getAll($where, 'field_order', 1);


        unset($where);


        if ($next_page or $prev_page){


            $query = "(fi.type != 'break'";


            if ($next_page) $query .= " or fi.id = $next_page->id";


            if ($prev_page) $query .= " or fi.id = $prev_page_obj->id";


            $query .= ") and fi.form_id=$form_id";


            if ($prev_page) $query .= " and fi.field_order >= $prev_page";


            if ($next_page) $query .= " and fi.field_order <= $next_page->field_order";


            if (is_admin()) $query .= " and fi.type != 'captcha'";


            $fields = $arffield->getAll($query, ' ORDER BY field_order');


        }


        if($next_page)


            $arfnextpage[$form_id] = $next_page->name;


        else


            unset($arfnextpage[$form_id]);


        return $fields;


    }
	
	function get_form_fields_tmp($fields, $form_id, $error=false, $previous=false){


        global $arfprevpage, $arffield, $arfnextpage;
		
		
		$query = "fi.form_id=". (int)$form_id;
		
		$fields = $arffield->getAll($query, ' ORDER BY field_order');
		
		return $fields;
		

    }

    function get_basic_default_html($type='text'){


        if (apply_filters('arfdisplayfieldhtml', true, $type)){


            $for = (in_array($type, array('radio', 'checkbox', 'data'))) ? '' : 'for="field_[key]"';


            $default_html = '<div id="arf_field_[id]_container" class="arfformfield control-group arfmainformfield [required_class][error_class]"  [field_style]>

<label '.$for.' class="arf_main_label">[field_name]

<span class="arfcheckrequiredfield">[required_label]</span>

</label>

[input]

[if description]<div class="arf_field_description" [description_style]>[description]</div>[/if description]

[if error]<div class="arf_frm_error" [description_style]>[error]</div>[/if error]

</div>';


        }else


            $default_html = apply_filters('arfothercustomhtml', '', $type);





        return apply_filters('arfcustomhtml', $default_html, $type);


    }
	
	function get_default_field_options($type, $field, $limit=false){


        $field_options = array(


            'size' => '', 'max' => '', 'label' => '', 'blank' => '', 


            'required_indicator' => '*', 'invalid' => '', 'separate_value' => 0,


            'clear_on_focus' => 0, 'default_blank' => 0, 'classes' => 'arf_1',


            'custom_html' => '', 'star_color'=>'yellow', 'star_size'=>'small', 'star_val'=>'',
			
			'first_page_label' => 'Step1', 'second_page_label' => 'Step2', 'pre_page_title' => 'Previous', 'next_page_title' => 'Next', 'page_break_type' => 'wizard', 'page_break_first_use' => '0','is_recaptcha'=>'recaptcha',
			'inline_css' => '', 'css_outer_wrapper' => '', 'css_label' => '', 'css_input_element' => '', 'css_description'	=> '',
			
			'file_upload_text' => 'Upload', 'file_remove_text' => 'Remove', 'upload_btn_color' => '#077bdd', 'arf_divider_font' => 'Helvetica',
			
			'arf_divider_font_size' => '16', 'arf_divider_font_style' => 'bold', 'arf_divider_bg_color' => '#ffffff',
			
			'lbllike' => __('Like', 'ARForms'), 'lbldislike' => __('Dislike', 'ARForms'), 'slider_handle' => 'round', 'slider_step' => '1',
			
			'slider_bg_color' => '#d1dee5', 'slider_handle_color' => '#0480BE', 'slider_value' => '1',
			
			'like_bg_color' => '#087ee2', 'dislike_bg_color' => '#ff1f1f', 'slider_bg_color2' => '#bcc7cd',
			
			'upload_font_color' => '#ffffff', 'confirm_password' => 0, 'password_strength' => 0, /*'confirm_password_field' => '',
			
			'is_set_confirm' => 0,*/ 'invalid_password' => __('Confirm Password does not match with password', 'ARForms'),
			
			/*'is_confirm_password' => 0,*/ 'placehodertext' => '', 'phone_validation' => 'international', 'confirm_password_label' => __('Confirm Password', 'ARForms')     
        );

		
     	if($type == 'captcha')
			$field_options['invalid'] = __('The reCAPTCHA was not entered correctly', 'ARForms');
		else if($type == 'email')	   
			$field_options['invalid'] = __('Email is invalid', 'ARForms');
		else if($type == 'file')	   
			$field_options['invalid'] = __('File is invalid', 'ARForms');
		else if($type == 'number')	   
			$field_options['invalid'] = __('Number is invalid', 'ARForms');
		else if($type == 'phone')	   
			$field_options['invalid'] = __('Phone is invalid', 'ARForms');
		else if($type == 'image')	   
			$field_options['invalid'] = __('Image is invalid', 'ARForms');
		else if($type == 'date')	   
			$field_options['invalid'] = __('Date is invalid', 'ARForms');
		else if($type == 'url')	   
			$field_options['invalid'] = __('Website is invalid', 'ARForms');	   	   	   		   	   	   	   
		
		
        if($limit)


            return $field_options;


        


        global $MdlDb, $armainhelper, $arfsettings;


        


        $form_id = (is_numeric($field)) ? $field : $field->form_id;


        


        $key = is_numeric($field) ? armainhelper::get_unique_key('', $MdlDb->fields, 'field_key') : $field->field_key;


        $field_count = $armainhelper->getRecordCount("form_id='$form_id'", $MdlDb->fields);


        


        return array(


            'name' => __('Untitled', 'ARForms'), 'description' => '', 


            'field_key' => $key, 'type' => $type, 'options'=>'', 'default_value'=>'', 


            'field_order' => $field_count+1, 'required' => false, 


            'blank' => $arfsettings->blank_msg, 'unique_msg' => $arfsettings->unique_msg,


            'invalid' => __('This field is invalid', 'ARForms'), 'form_id' => $form_id,


            'field_options' => $field_options


        );


    }

	function show_onfocus_js($field_id, $clear_on_focus){ 
    }


    function get_default_html($default_html, $type){


        if ($type == 'break'){


            $default_html = '<h2 class="pos_[label_position]">[field_name]</h2>

[if description]<div class="arf_field_description">[description]</div>[/if description]';


        }else if ($type == 'divider'){


            $default_html = '<div id="heading_[id]" class="arf_heading_div" [field_style]>

<h2 class="arf_sec_heading_field pos_[label_position][collapse_class]">[field_name]</h2>

[collapse_this]

[if description]<div class="arf_field_description arf_heading_description" [description_style]>[description]</div>[/if description]

</div>';


        }else if($type == 'html'){


            $default_html = '<div id="arf_field_[id]_container" class="arfformfield control-group arfmainformfield [error_class]" [field_style]>[description]</div>';       


        }


        return $default_html;


    }


    function replace_field_shortcodes($html, $field, $errors=array(), $form=false){


        global $arfreadonly;


        


        $html = stripslashes($html);


        $html = apply_filters('arfbeforereplaceshortcodes', $html, $field, $errors, $form);


        


        $field_name = 'item_meta['. $field['id'] .']';


        if(isset($field['multiple']) and $field['multiple'] and ($field['type'] == 'select' or ($field['type'] == 'data' and isset($field['data_type']) and $field['data_type'] == 'select')))


            $field_name .= '[]';


        


        $html = str_replace('[id]', $field['id'], $html);


 

        $html = str_replace('[key]', $field['field_key'], $html);



        $required = ($field['required'] == '0') ? '' : $field['required_indicator'];


        if(!is_array($errors))


            $errors = array();


        $error = (isset($errors['field'. $field['id']])) ? stripslashes($errors['field'. $field['id']]) : false; 


        foreach (array('description' =>$field['description'], 'required_label' => $required, 'error' => $error) as $code => $value){
			
			if($code == 'description'){	
				if($field['type'] != 'html' && $field['type'] != 'divider' )
					$value = '';
			}
			
            if (!$value or $value == '')


                $html = preg_replace('/(\[if\s+'.$code.'\])(.*?)(\[\/if\s+'.$code.'\])/mis', '', $html);


            else{


                $html = str_replace('[if '.$code.']', '', $html); 


        	    $html = str_replace('[/if '.$code.']', '', $html);


            }





            $html = str_replace('['.$code.']', $value, $html);
			
			
			$description_style = ( isset($field['field_width']) and $field['field_width'] == '' ) ? 'style="width:'.$field['field_width'].'px;"' : '';	
			
			$html = str_replace('[description_style]', $description_style, $html);	


        }        

		//---------- for conditional logic ----------//
		$field_style = arfieldhelper::get_display_style($field);
		
		$html = str_replace('[field_style]', $field_style, $html);
		//---------- for conditional logic ----------//


        $required_class = ($field['required'] == '0') ? '' : ' arffieldrequired';            

		if( $field['type'] == 'confirm_password' )
			$required_class .= ' confirm_password_container '; 
			
        $html = str_replace('[required_class]', $required_class, $html);  


		
		global $db_record, $arfform, $arffield, $arfajaxurl, $MdlDb, $wpdb;
		
		if( $form->id >= 10000 )
			$data = $wpdb->get_results( $wpdb->prepare("SELECT * FROM ".$wpdb->prefix."arf_ref_forms WHERE id = %d", $form->id), 'ARRAY_A');
		else
			$data = $wpdb->get_results( $wpdb->prepare("SELECT * FROM ".$wpdb->prefix."arf_forms WHERE id = %d", $form->id), 'ARRAY_A');
		
		$aweber_arr = "";
		$aweber_arr   = $data[0]['form_css'];
		
		$newarr = array();
		
		if($aweber_arr != "") {
		$arr = maybe_unserialize($aweber_arr);
		
		
		
		foreach($arr as $k => $v)
			$newarr[$k] = $v;
		}
		$values['label_position'] = ($newarr['hide_labels']=='1') ? 'none' : $newarr['position'];
		
		
		global $style_settings;
		
		$field['label'] = ($values['label_position'] and $values['label_position'] != '') ? $values['label_position'] : $style_settings->position;
		
		
        $html = str_replace('[label_position]', (($field['type'] == 'divider' or $field['type'] == 'break') ? $field['label'] : ' arf_main_label'), $html);


        

        $html = str_replace('[field_name]', $field['name'], $html);



        $error_class = isset($errors['field'. $field['id']]) ? ' arfblankfield' : '';


        $error_class .= ' '. $field['label'] .'_container' ;


     

        //if(!empty($field['classes'])){
		if( isset($field['classes']) ){
	
            if(!strpos($html, 'arfformfield '))


                $error_class .= ' arfformfield';

			global $arf_column_classes;
			
			if( isset($field['classes']) and $field['classes'] == 'arf_2' and empty($arf_column_classes['two']) ){
				$arf_column_classes['two'] = '1';
				$arf_classes = 'frm_first_half';				
				
				$arf_column_classes['three'] = '';
				unset($arf_column_classes['three']);
			} else if( isset($field['classes']) and $field['classes'] == 'arf_2' and isset($arf_column_classes['two']) and $arf_column_classes['two']=='1'){
				$arf_classes = 'frm_last_half';				
				$arf_column_classes['two'] = '';
				
				unset($arf_column_classes['two']);
				$arf_column_classes['three'] = '';
				unset($arf_column_classes['three']);				
			} else if( isset($field['classes']) and $field['classes'] == 'arf_3' and empty($arf_column_classes['three']) ){
				$arf_column_classes['three'] = '1';
				$arf_classes = 'frm_first_third';
				
				$arf_column_classes['two'] = '';
				unset($arf_column_classes['two']);
			} else if( isset($field['classes']) and $field['classes'] == 'arf_3' and isset($arf_column_classes['three']) and $arf_column_classes['three'] == '1' ){
				$arf_column_classes['three'] = '2';
				$arf_classes = 'frm_third';
				
				$arf_column_classes['two'] = '';
				unset($arf_column_classes['two']);	
			} else if( isset($field['classes']) and $field['classes'] == 'arf_3' and isset($arf_column_classes['three']) and $arf_column_classes['three'] == '2' ){
				$arf_classes = 'frm_last_third';
								
				$arf_column_classes['three'] = '';				
				unset($arf_column_classes['three']);
				$arf_column_classes['two'] = '';
				unset($arf_column_classes['two']);						
			} else {
				$arf_column_classes = array();
				$arf_classes = '';
			}
			
			if( isset($arf_column_classes['three']) and $arf_column_classes['three'] == '3' ){
				$arf_column_classes['three'] = '';
				unset($arf_column_classes['three']);		
			} 
			if( isset($arf_column_classes['two']) and $arf_column_classes['two'] == '2' ){
				$arf_column_classes['two'] = '';
				unset($arf_column_classes['two']);	
			}
			
            $error_class .= ' '. $arf_classes;


        }


        $html = str_replace('[error_class]', $error_class, $html);


        

        $entry_key = (isset($_GET) and isset($_GET['entry'])) ? $_GET['entry'] : '';


        $html = str_replace('[entry_key]', $entry_key, $html);



        preg_match_all("/\[(input|deletelink)\b(.*?)(?:(\/))?\]/s", $html, $shortcodes, PREG_PATTERN_ORDER);





        foreach ($shortcodes[0] as $short_key => $tag){


            $atts = shortcode_parse_atts( $shortcodes[2][$short_key] );





            if(!empty($shortcodes[2][$short_key])){


                $tag = str_replace('[', '',$shortcodes[0][$short_key]);


                $tag = str_replace(']', '', $tag);


                $tags = explode(' ', $tag);


                if(is_array($tags))


                    $tag = $tags[0];


            }else


                $tag = $shortcodes[1][$short_key];


               


            $replace_with = ''; 


            


            if($tag == 'input'){


                if(isset($atts['opt'])) $atts['opt']--;


                $field['input_class'] = isset($atts['class']) ? $atts['class'] : '';


                if(isset($atts['class']))


                    unset($atts['class']);


                $field['shortcodes'] = $atts;


                ob_start();


                include(VIEWS_PATH.'/inputelements.php');


                $replace_with = ob_get_contents();


                ob_end_clean();


            }else if($tag == 'deletelink' and class_exists('arrecordcontroller'))


                $replace_with = arrecordcontroller::entry_delete_link($atts);


            


            $html = str_replace($shortcodes[0][$short_key], $replace_with, $html);


        }


        


        if($form){


            $form = (array)$form;


            


            $html = str_replace('[form_key]', $form['form_key'], $html);


           

            $html = str_replace('[form_name]', $form['name'], $html);


        }


        $html .= "\n";


        


        return apply_filters('arfreplaceshortcodes', $html, $field, array('errors' => $errors, 'form' => $form));


    }
	
	function display_recaptcha($field, $error=null){


    	global $arfsettings;


    	


    	if(!function_exists('recaptcha_get_html'))


            require_once(FORMPATH.'/core/recaptchalib.php');


        


        $lang = apply_filters('arfrecaptchalang', $arfsettings->re_lang, $field);


        


        if(defined('DOING_AJAX')){ 


            global $arfrecaptchaloaded;


            if(!$arfrecaptchaloaded)


                $arfrecaptchaloaded = '';


            


            $arfrecaptchaloaded .= "Recaptcha.create('". $arfsettings->pubkey ."','field_". $field['field_key'] ."',{theme:'". $arfsettings->re_theme ."',lang:'". $lang ."'". apply_filters('arfrecaptchacustom', '', $field) ."});";


?>


<div id="field_<?php echo $field['field_key'] ?>"></div>


<?php   }else{ ?>


<script type="text/javascript">var RecaptchaOptions={theme:'<?php echo $arfsettings->re_theme ?>',lang:'<?php echo $lang ?>'<?php echo apply_filters('arfrecaptchacustom', '', $field) ?>};</script>


<?php       echo '<div id="recaptcha_style">'.recaptcha_get_html($arfsettings->pubkey .'&hl='. $lang, $error, is_ssl()).arfieldhelper::replace_description_shortcode($field).'</div>';


        }


    }


    function before_replace_shortcodes($html, $field,$error,$form){
		
		if($form != '')
		{
			$form_css = maybe_unserialize($form->form_css);
			if(is_array($form_css))
			{		
				$arfcheckboxalignsetting = $form_css['arfcheckboxalignsetting'];
				$arfradioalignsetting = $form_css['arfradioalignsetting'];
			}
		}		
        global $style_settings;		
		
        if(isset($field['align']) and ($field['type'] == 'radio' or $field['type'] == 'checkbox')){


            $required_class = '[required_class]';
			
            if(($field['type'] == 'radio' and $field['align'] != $arfradioalignsetting) or 


                ($field['type'] == 'checkbox' and $field['align'] != $arfcheckboxalignsetting)){
				
				if( $field['align'] != 'global' )	
                	$required_class .= ($field['align'] == 'inline') ? ' arf_horizontal_radio' : ' arf_vertical_radio';


                $html = str_replace('[required_class]', $required_class, $html);


            }


        }


        if(isset($field['classes']) and strpos($field['classes'], 'frm_grid') !== false){


            $opt_count = count($field['options']) + 1;


            $html = str_replace('[required_class]', '[required_class] frm_grid_'. $opt_count, $html);


            unset($opt_count);


        }


        return $html;


    }


    


    function replace_html_shortcodes($html, $field){


        if ($field['type'] == 'divider'){


            global $arfdiv;


            $trigger = '';


            $html = str_replace(array('none_container', 'top_container', 'left_container', 'right_container'), '', $html);
			
			global $MdlDb, $arf_page_number;
			$page_num = $MdlDb->get_count($MdlDb->fields, array("form_id" => $field['form_id'], "type" => 'break'));

			if($page_num > 0) {
				$collapse_div = '<div class="divider_'.$arf_page_number.'">'."\n";
			} else {
            	$collapse_div = '<div>'."\n";
			}
			
            if (preg_match('/\[(collapse_this)\]/s', $html)){
				global $arf_section_div;
				
				if( $arf_section_div ) {
                	$html = "<div class='arf_clear'></div></div>\n". $html;
				} else {
					$arf_section_div = 1;
				}
				
                $html = str_replace('[collapse_this]', $collapse_div, $html);


            }

			//---------- for conditional logic ----------//
			$field_style = arfieldhelper::get_display_style($field);
		
			$html = str_replace('[field_style]', $field_style, $html);
			//---------- for conditional logic ----------//
                


            $html = str_replace('[collapse_class]', $trigger, $html);


        }else if($field['type'] == 'html'){


            $html = apply_filters('arfgetdefaultvalue', $html, (object)$field, false);


            $html = do_shortcode($html);


        }


        return $html;


    }


    function get_file_icon($media_id){


        if ( !is_numeric($media_id) )


            return;
		
		$image_array = wp_get_attachment_image_src($media_id, array(150,150),true);

		$image_array_link = str_replace('thumbs/','',$image_array[0]);              
		
		$img_size = @getimagesize($image_array[0]);
		
		$img_height = $img_width = '';
				
		$img_height = $img_size[1];
		
		$img_height = ($img_height == '' ) ? '' : 'height="'.$img_height.'"';
		
		$img_width = $img_size[0];
		
		$img_width = ($img_width == '' ) ? '' : 'width="'.$img_width.'"';
		
		
		$image = '<img class="attachment-thumnail" alt="'.$image_array[0].'" src="'.$image_array[0].'" border="0" '.$img_height.' '.$img_width.'>';
		
        if($image and !preg_match("/wp-content\/uploads/", $image)){ 


            $attachment = get_post($media_id);


            $label = basename($attachment->guid);


            $image = arfieldhelper::get_file_name_link($media_id);
			
			$image .= '<img class="attachment-thumnail" alt="'.$image_array[0].'" src="'.$image_array[0].'" border="0" '.$img_height.' '.$img_width.'></a>';


        }else{
			$image = '<a href="'.$image_array_link.'" target="_blank"><img class="attachment-thumnail" alt="'.$image_array[0].'" src="'.$image_array[0].'" border="0" '.$img_height.' '.$img_width.'></a>';
		}


        return $image;


    }

	function get_file_name_link($media_id, $short=true)
	{
        if ( is_numeric($media_id) ){
		
    		if ($short){
			
    		    $attachment = get_post($media_id);
				
                $label = basename($attachment->guid);
            }
            $url = wp_get_attachment_url($media_id);
		
			$url = str_replace('thumbs/','',$url);              
        
		    if (is_admin()){
                global $arfsiteurl;

                $url = '<a href="'.$url.'">';
            }

            return $url;
    	}
    }
    


    function get_file_name($media_id, $short=true){


        if ( is_numeric($media_id) ){


    		if ($short){


    		    $attachment = get_post($media_id);


                $label = basename($attachment->guid);


            }


            $url = wp_get_attachment_url($media_id);

			$url = str_replace('thumbs/','',$url);              


            if (is_admin()){


                global $arfsiteurl;


                $url = '<a href="'.$url.'">'.$label.'</a>';

            }


            return $url;


    	}


    }


    function get_date($date, $date_format=false){


        if(empty($date))

            return $date;


        if (!$date_format)

            $date_format = get_option('date_format');

        
		if (preg_match('/^\d{1-2}\/\d{1-2}\/\d{4}$/', $date)){ 

            global $style_settings;

            $date = armainhelper::convert_date($date, $style_settings->date_format, 'Y-m-d');
        }
		
		$date = str_replace('/', '-', $date);
		
		if( strtotime($date) == '' )	
			return $date;
			
        return date_i18n($date_format, strtotime($date));

    }


    function get_field_options($form_id, $value='', $include='not', $types="'break','divider','data','file','captcha'", $data_children=false){


        global $arffield;


        $fields = $arffield->getAll("fi.type $include in ($types) and fi.form_id=". (int)$form_id, 'fi.field_order');


        foreach ($fields as $field){ 


            $field->field_options = maybe_unserialize($field->field_options);

			 ?>
            <option value="<?php echo $field->id ?>" <?php selected($value, $field->id) ?>><?php echo armainhelper::truncate($field->name, 50) ?></option>
        <?php   


        }


    }

    function value_meets_condition($observed_value, $cond, $hide_opt){ 


        if($hide_opt == '')


            return false;


            


        if(is_array($observed_value)){


            if($cond == '=='){


                $m = in_array($hide_opt, $observed_value);


            }else if($cond == '!='){


                $m = !in_array($hide_opt, $observed_value);


            }else if($cond == '>'){


                $min = min($observed_value);


                $m = $min > $hide_opt;


            }else if($cond == '<'){


                $max = max($observed_value);


                $m = $max < $hide_opt;


            } 


        }else{


            if($cond == '==')


                $m = $observed_value == $hide_opt;


            else if($cond == '!=')


                $m = $observed_value != $hide_opt;


            else if($cond == '>')


                $m = $observed_value > $hide_opt;


            else if($cond == '<')


                $m = $observed_value < $hide_opt;


        }


        return $m;


    }



    function get_shortcode_select($form_id, $target_id='content', $type='all', $style=''){ 


        global $arffield, $MdlDb;  


        $field_list = array();


        if(is_numeric($form_id)){


            $exclude = "'divider','captcha','break','html'";


            if($type == 'field_opt')


                $exclude .= ",'data','checkbox'";


            $field_list = $arffield->getAll("fi.type not in (". $exclude .") and fi.form_id=". (int)$form_id, 'field_order');


        }


        $linked_forms = array();

       ?>

        <select class="frm_shortcode_select" onchange="arfaddcodefornewfield('<?php echo $target_id ?>',this.value);this.value='';" <?php echo (isset($style))? $style : '';?> data-width='330px'>


            <option value="">- <?php _e('Select a value to insert into the box below', 'ARForms') ?> -</option>


            <?php if($type != 'field_opt'){ ?>

			
            

            


            <?php }


            if(!empty($field_list)){


            foreach ($field_list as $field){ 


                $field->field_options = maybe_unserialize($field->field_options);

            ?>
                <option value="[<?php echo ($field->ref_field_id > 0 ) ? $field->ref_field_id : $field->id; ?>]"><?php echo $field_name = armainhelper::truncate($field->name, 60) ?> </option>

                <?php 


            }


            }


            if($type != 'field_opt'){ ?>


            </optgroup>



            <?php } ?>


        </select>    


    <?php    


    }


    


    function replace_shortcodes($content, $entry, $shortcodes, $display=false, $show='one', $odd=''){


        global $arffield, $arfrecordmeta, $post, $style_settings;





        if($display){


            $param_value = ($display->type == 'id') ? $entry->id : $entry->entry_key;


            


            if($entry->attachment_id){


                $detail_link = get_permalink($entry->attachment_id);


            }else{


                $param = (isset($display->param) && !empty($display->param)) ? $display->param : 'entry';


                if($post)


                    $detail_link = add_query_arg($param, $param_value, get_permalink($post->ID));


                else


                    $detail_link = add_query_arg($param, $param_value);


            }


        }


        


        foreach ($shortcodes[0] as $short_key => $tag){


            $conditional = false;


            $atts = shortcode_parse_atts( $shortcodes[3][$short_key] );





            if(!empty($shortcodes[3][$short_key])){


                if($conditional)


                    $tag = str_replace('[if ', '', $shortcodes[0][$short_key]);


                else


                    $tag = str_replace('[', '',$shortcodes[0][$short_key]);


                $tag = str_replace(']', '', $tag);


                $tags = explode(' ', $tag);


                if(is_array($tags))


                    $tag = $tags[0];


            }else


                $tag = $shortcodes[2][$short_key];


                             


            switch($tag){                


                case 'detaillink':


                    if($display and $detail_link)


                        $content = str_replace($shortcodes[0][$short_key], $detail_link, $content);


                break;


                case 'id':


                    $content = str_replace($shortcodes[0][$short_key], $entry->id, $content);


                break;


                case 'post-id':


                case 'attachment_id':


                    $content = str_replace($shortcodes[0][$short_key], $entry->attachment_id, $content);


                break;


                


                case 'key':


                    $content = str_replace($shortcodes[0][$short_key], $entry->entry_key, $content);


                break;


                


                case 'ip_address':


                    $content = str_replace($shortcodes[0][$short_key], $entry->ip_address, $content);


                break;


                


                case 'user_agent':


                case 'user-agent':


                    $entry->description = maybe_unserialize($entry->description);


                    $content = str_replace($shortcodes[0][$short_key], $entry->description['browser'], $content);


                break;


                


                case 'created-at':


                case 'updated-at':


                case 'evenodd':


                    $content = str_replace($shortcodes[0][$short_key], $odd, $content);


                break;


                


                case 'siteurl':


                    global $arfsiteurl;


                    $content = str_replace($shortcodes[0][$short_key], $arfsiteurl, $content);


                break;


                


                case 'sitename':


                    $content = str_replace($shortcodes[0][$short_key], get_option('blogname'), $content);


                break;


                


                case 'get':


                    if(isset($atts['param'])){


                        $param = $atts['param']; 


                        $replace_with = armainhelper::get_param($param);


                        if(is_array($replace_with))


                            $replace_with = implode(', ', $replace_with);


                        


                        $content = str_replace($shortcodes[0][$short_key], $replace_with, $content);


                        unset($param);


                        unset($replace_with);


                    }


                break;


                


                default:


                    if($tag == 'deletelink'){


                        $page_id = isset($atts['page_id']) ? $atts['page_id'] : $post->ID;


                        


                        $can_delete = arrecordhelper::allow_delete($entry);


                        if($can_delete){


                            if(isset($atts['label'])){


                                $delete_atts = $atts;


                                $delete_atts['id'] = $entry->id;


                                $delete_atts['page_id'] = $page_id;





                                $replace_with = arrecordcontroller::entry_delete_link($delete_atts);


                                unset($delete_atts);


                            }else{


                                $replace_with = add_query_arg(array('arfaction' => 'destroy', 'entry' => $entry->id), get_permalink($page_id));


                            }


                        }else{


                            $replace_with = '';


                        }


                        $field = false;


                    }else{


                        $field = $arffield->getOne( $tag );


                    }


                    


                    $sep = (isset($atts['sep'])) ? $atts['sep'] : ', ';


                    


                    if(!isset($field))


                        $field = false;


                        


                    if($field){


                        $field->field_options = maybe_unserialize($field->field_options);


                        $replace_with = arrecordhelper::get_post_or_entry_value($entry, $field, $atts);


                        $replace_with = maybe_unserialize($replace_with);


                        $atts['entry_id'] = $entry->id;


                        $atts['entry_key'] = $entry->entry_key;


                        $atts['attachment_id'] = $entry->attachment_id;


                        $replace_with = apply_filters('arffieldsreplaceshortcodes', $replace_with, $tag, $atts, $field); 


                    }   


                    


                    if (isset($replace_with) and is_array($replace_with))


                        $replace_with = implode($sep, $replace_with);





                    if ($field and $field->type == 'file'){



                        $size = (isset($atts['size'])) ? $atts['size'] : 'thumbnail';


                        if($size != 'id')


                            $replace_with = arfieldhelper::get_media_from_id($replace_with, $size);


                    }

                    


                        if($field){


                            if (isset($atts['show']) and $atts['show'] == 'field_label'){


                                $replace_with = stripslashes($field->name);


                            }else if (empty($replace_with) and $replace_with != '0'){


                                $replace_with = '';


                                if ($field->type == 'number')


                                    $replace_with = '0';


                            }else{


                                $replace_with = arfieldhelper::get_display_value($replace_with, $field, $atts);


                            }


                        }


                            


                        if (isset($atts['sanitize']))


                            $replace_with = sanitize_title_with_dashes($replace_with);


                            


                        if (isset($atts['sanitize_url']))


                            $replace_with = urlencode(htmlentities($replace_with));


                            


                        if (isset($atts['truncate'])){


                            if(isset($atts['more_text'])){


                                $more_link_text = $atts['more_text'];


                            }else


                                $more_link_text = (isset($atts['more_link_text'])) ? $atts['more_link_text'] : '. . .';


                                


                            if ($display and $show == 'all'){


                                $more_link_text = ' <a href="'.$detail_link.'">'.$more_link_text.'</a>';


                                $replace_with = armainhelper::truncate($replace_with, (int)$atts['truncate'], 3, $more_link_text); 


                            }else{


                                $replace_with = wp_specialchars_decode(strip_tags($replace_with), ENT_QUOTES);


                                $part_one = substr($replace_with, 0, (int)$atts['truncate']);


                                $part_two = substr($replace_with, (int)$atts['truncate']);


                                $replace_with = $part_one .'<a onclick="jQuery(this).next().css(\'display\', \'inline\');jQuery(this).css(\'display\', \'none\')" class="frm_text_exposed_show"> '. $more_link_text .'</a><span style="display:none;">'. $part_two .'</span>';


                            }


                        }


                        


                        if(isset($atts['clickable']))


                            $replace_with = make_clickable($replace_with);





                        if (!isset($replace_with))


                            $replace_with = '';


                            


                        $content = str_replace($shortcodes[0][$short_key], $replace_with, $content);


                        


                    

                    unset($replace_with);


                    


                    if(isset($field))


                        unset($field);


            }


            unset($atts);


            unset($conditional);


         }


         return $content;


     }


     function get_media_from_id($replace_with, $size='thumbnail'){


         if($size == 'label'){


            $attachment = get_post($replace_with);


            $replace_with = basename($attachment->guid);


        }else{


            $image = wp_get_attachment_image_src($replace_with, $size); 



            if($image)


                $replace_with = $image[0];


            else


                $replace_with = wp_get_attachment_url($replace_with);


         }


         


         return $replace_with;


     }


     function get_display_value($replace_with, $field, $atts=array()){


         $sep = (isset($atts['sep'])) ? $atts['sep'] : ', ';


         if ($field->type == 'date'){


             if(isset($atts['time_ago']))


                 $atts['format'] = 'Y-m-d H:i:s';


                 


             if(!isset($atts['format']))


                $atts['format'] = false;


             


             $replace_with = arfieldhelper::get_date($replace_with, $atts['format']);


             


             if(isset($atts['time_ago']))


                 $replace_with = armainhelper::human_time_diff( strtotime($replace_with), strtotime(date_i18n('Y-m-d')) );


         }else if (is_numeric($replace_with) and $field->type == 'file'){ 


             $size = (isset($atts['size'])) ? $atts['size'] : 'thumbnail';


             if($size != 'id')


                 $replace_with = arfieldhelper::get_media_from_id($replace_with, $size);


         }else if($field->type == 'textarea'){


             $autop = isset($atts['wpautop']) ? $atts['wpautop'] : true;


             if(apply_filters('arfusewpautop', $autop))


                 $replace_with = wpautop($replace_with);


             unset($autop);


         }else if($field->type == 'number'){


             if(!isset($atts['decimal'])){


                 $num = explode('.', $replace_with);


                 $atts['decimal'] = (isset($num[1])) ? strlen($num[1]) : 0;


              }


              


              if(!isset($atts['dec_point']))


                 $atts['dec_point'] = '.';


                 


              if(!isset($atts['thousands_sep']))


                 $atts['thousands_sep'] = '';


              


              $replace_with = number_format($replace_with, $atts['decimal'], $atts['dec_point'], $atts['thousands_sep']);


         }

         $replace_with = stripslashes_deep($replace_with);


         return $replace_with;


     }


     


     function get_table_options($field_options){


 		$columns = array();


 		$rows = array();


 		if (is_array($field_options)){


 			foreach ($field_options as $opt_key => $opt){


 				switch(substr($opt_key,0,3)){


 				case 'col':


 					$columns[$opt_key] = $opt;


 					break;


 				case 'row':


 					$rows[$opt_key] = $opt;


 					break;


 				}


 			}


 		}


 		return array($columns,$rows);


 	}





 	function set_table_options($field_options, $columns, $rows){


 		if (is_array($field_options)){


 			foreach ($field_options as $opt_key => $opt){


 				if (substr($opt_key, 0, 3) == 'col' or substr($opt_key, 0, 3) == 'row')


 					unset($field_options[$opt_key]);


 			}


 		}else


 			$field_options = array();


 		


 		foreach ($columns as $opt_key => $opt)


 			$field_options[$opt_key] = $opt;


 		


 		foreach ($rows as $opt_key => $opt)


 			$field_options[$opt_key] = $opt;


 		


 		return $field_options;


 	}


	function show_default_blank_js($field_id, $default_blank){ 
	
    }
	
	//---------- for conditional logic ----------//
	function arf_cl_field_menu($form_id, $select_name, $select_id='', $default_field_id=0){
		global $arffield;
		
		if(empty($form_id) or !$form_id)
			return false;

		$fields = $arffield->getAll("fi.type not in ('divider', 'captcha', 'break', 'html', 'file') and fi.form_id=". (int)$form_id, 'field_order');
		
		if( count($fields) > 0 ) {
				
		$select_id = (isset($select_id)) ? $select_id : $select_name; 
		
		echo '<select name="'.$select_name.'" id="'.$select_id.'" class="field_dropdown_menu" data-size="10" data-width="150px">';	
			foreach($fields as $field) {
				
				$field_id = arfieldhelper::get_actual_id($field->id);
				
				if($default_field_id != 0 and $default_field_id == $field_id)
					echo '<option value="'.$field_id.'" selected="selected">'.$field->name.'</option>';
				else
					echo '<option value="'.$field_id.'">'.$field->name.'</option>';
			}	
		echo '</select>';
		}
				
	}
	
	function arf_cl_rule_menu($select_name, $select_id='', $default_rule='is'){
		
		$conditional_rules = array(
								'is' 			=> __('equals', 'ARForms'),
								'is not' 		=> __('not equals', 'ARForms'),
								'greater than' 	=> __('greater than', 'ARForms'),
								'less than' 	=> __('less than', 'ARForms'),
								'contains' 		=> __('contains', 'ARForms'),
								'not contains' 	=> __('not contains', 'ARForms'),
									);
		
		$select_id = (isset($select_id)) ? $select_id : $select_name; 
			
		echo '<select name="'.$select_name.'" class="operator_dropdown_menu" id="'.$select_id.'" data-width="150px">';	
			foreach($conditional_rules as $rule_id => $rule) {
				
				if( isset($default_rule) and $default_rule == $rule_id)
					echo '<option value="'.$rule_id.'" selected="selected">'.$rule.'</option>';
				else
					echo '<option value="'.$rule_id.'">'.$rule.'</option>';
			}	
		echo '</select>';
				
	}
	
	function get_actual_id($field_id){
		global $wpdb, $MdlDb;
		$res = $wpdb->get_results($wpdb->prepare("select ref_field_id from ".$MdlDb->fields." where id = %d", $field_id));
		$res = $res[0];
		
		$id = ( $res->ref_field_id > 0 ) ? $res->ref_field_id : $field_id;
		return $id;
	}
	
	function get_field_type($filed_id = ''){
	
		if( empty($filed_id) or $filed_id == '')
			return false;
		
		global $wpdb, $MdlDb;
		$res = $wpdb->get_results($wpdb->prepare("SELECT id, type FROM ".$MdlDb->fields." WHERE id = %d", $filed_id));
		$res = $res[0];
		
		return $res->type;	
	}
	
	function get_onchage_func($field=''){
		
		if( empty($field) or $field == '' or is_admin() )
			return false;
		$field['id'] = arfieldhelper::get_actual_id($field['id']);	
		global $wpdb, $MdlDb;
		if( $field['form_id'] >= 10000 )
			$form = $wpdb->get_results($wpdb->prepare("SELECT form_key, options FROM ".$MdlDb->ref_forms." WHERE id = %d", $field['form_id']));
		else
			$form = $wpdb->get_results($wpdb->prepare("SELECT form_key, options FROM ".$MdlDb->forms." WHERE id = %d", $field['form_id']));
			
		$form = $form[0];
		
		$res = $wpdb->get_results($wpdb->prepare("SELECT id, conditional_logic FROM ".$MdlDb->fields." WHERE form_id = %d ORDER BY field_order", $field['form_id']));
		
		$string = '';	
		foreach( $res as $data ){
			$conditional_logic = maybe_unserialize($data->conditional_logic);
			if( isset($conditional_logic['enable']) and $conditional_logic['enable'] == 1) {
				if( count($conditional_logic['rules']) > 0 ) {
					
					foreach($conditional_logic['rules'] as $val){
						
						if( $val['field_id'] == $field['id'] ) {
						$data->id = arfieldhelper::get_actual_id($data->id);
							$string .= $data->id.',';
							}
											
					}
				
				}
			}
		}
		
		$formoptions = maybe_unserialize( $form->options );
		$submit_conditional_logic = $formoptions['submit_conditional_logic'] ? $formoptions['submit_conditional_logic'] : array();
		  
		if( isset($submit_conditional_logic['enable']) and $submit_conditional_logic['enable'] == 1 ){
			if( count($submit_conditional_logic['rules']) > 0 ) {
					
				foreach($submit_conditional_logic['rules'] as $val){
					
					if( $val['field_id'] == $field['id'] ) {
						//$data->id = arfieldhelper::get_actual_id($data->id);
						$string .= "'arfsubmit',";//$data->id.',';
					}										
				}
			}
		}
		
		if( $string != '' ){
		
			$string = rtrim($string, ',');
			
			if( $field['type'] == 'checkbox' || $field['type'] == 'radio' || $field['type'] == 'like' ) {
				if( $field['type'] == 'radio' )
					return ' onclick="arf_rule_apply(\''.$form->form_key.'\', \''.$field['id'].'\', ['.$string.']);" ';
				else
					return ' onchange="arf_rule_apply(\''.$form->form_key.'\', \''.$field['id'].'\', ['.$string.']);" ';
					
			} else if( $field['type'] == 'select' || $field['type'] == 'time' || $field['type'] == 'scale' || $field['type'] == 'slider' ) {
				return ' onchange="arf_rule_apply(\''.$form->form_key.'\', \''.$field['id'].'\', ['.$string.']);" ';
			} else {
				return ' onchange="arf_rule_apply(\''.$form->form_key.'\', \''.$field['id'].'\', ['.$string.']);" onkeyup="setTimeout(function(){arf_rule_apply(\''.$form->form_key.'\', \''.$field['id'].'\', ['.$string.'])}, 100);" ';
			} 			
			
		} else 
			return '';	
	}
	
	function get_form_logic_rules($form_id, $form_key){
		
		if( empty($form_id) || $form_id == '' || empty($form_key) )
			return false;
			
		global $wpdb, $MdlDb;		
		$res = $wpdb->get_results($wpdb->prepare("SELECT * FROM ".$MdlDb->fields." WHERE form_id = %d ORDER BY field_order", $form_id));
		
		$logic_rules = '';
		$page_no = 0;	
		foreach( $res as $data ){

			if($data->type == 'break')
				$page_no++;	
			
			$conditional_logic = maybe_unserialize($data->conditional_logic);
						
			if( isset($conditional_logic['enable']) and $conditional_logic['enable'] == 1) {
					
				if( count($conditional_logic['rules']) > 0 ) {
					
					$string = '';
					foreach($conditional_logic['rules'] as $val){
						
						$string .= " { 'rule_no' : '".$val['id']."', 'field_id' : '".$val['field_id']."', 'field_type' : '".$val['field_type']."', 'operator' : '".$val['operator']."', 'value' : '".$val['value']."' },";					
					}
					
					$string = rtrim($string, ',');
					
					$default_value = self::get_field_defautl_value( $data ); 
					
					$logic_rules .= (($data->ref_field_id > 0) ? $data->ref_field_id : $data->id)." : { 'display': '".$conditional_logic['display']."', 'if_cond': '".$conditional_logic['if_cond']."', 'field_type': '".$data->type."', 'field_key': '".$data->field_key."', 'default_value': ".$default_value.", 'page': '".$page_no."', 'rules':[".$string."] }, ";
				
				}
				
			}
		}
		
		// for submit conditional logic
		
		if( $form_id >= 10000 )
			$form = $wpdb->get_results($wpdb->prepare("SELECT options FROM ".$MdlDb->ref_forms." WHERE id = %d", $form_id));
		else
			$form = $wpdb->get_results($wpdb->prepare("SELECT options FROM ".$MdlDb->forms." WHERE id = %d", $form_id));
			
		$form = $form[0];
		
		$formoptions = maybe_unserialize( $form->options );
		$submit_conditional_logic = $formoptions['submit_conditional_logic'] ? $formoptions['submit_conditional_logic'] : array();
		
		if( isset($submit_conditional_logic['enable']) and $submit_conditional_logic['enable'] == 1) {				
			if( count($submit_conditional_logic['rules']) > 0 ) {				
				$string = '';
				foreach($submit_conditional_logic['rules'] as $val){
					
					$string .= " { 'rule_no' : '".$val['id']."', 'field_id' : '".$val['field_id']."', 'field_type' : '".$val['field_type']."', 'operator' : '".$val['operator']."', 'value' : '".$val['value']."' },";					
				}
				
				$string = rtrim($string, ',');
				
				$default_value = '';//self::get_field_defautl_value( $data ); 
				
				$logic_rules .= "'arfsubmit' : { 'display': '".$submit_conditional_logic['display']."', 'if_cond': '".$submit_conditional_logic['if_cond']."', 'field_type': 'submit', 'field_key': '".$form_key."', 'default_value': '".$default_value."', 'page': '".$page_no."', 'rules':[".$string."] }, ";
			
			}
			
		}
		
		
		if( isset($logic_rules) and $logic_rules != '' ) {
			
			return '<div><script type="text/javascript" language="javascript">if(window[\'jQuery\']){ if(!window[\'arf_cl\']) window[\'arf_cl\'] = new Array(); window[\'arf_cl\'][\''.$form_key.'\'] = { '.$logic_rules.' }; }</script></div>';
		}
		
		return '';
	}
	
	function get_field_defautl_value( $field )
	{
		if( ! $field )
			return;
			
		$field = (array)$field;
		
		$value1 = '';		

		$field_options = maybe_unserialize($field['field_options']);
		$field['default_value'] = isset($field['default_value']) ? $field['default_value'] : '';
	
		$field_options['default_blank'] = isset($field_options['default_blank']) ? $field_options['default_blank'] : '';
		
		if((isset($field_options['clear_on_focus']) and $field_options['clear_on_focus'] and !empty($field['default_value']))){ 
		
			if($field_options['default_blank']==1){ $value1 = trim(armainhelper::esc_textarea($field['default_value'])); }
				
		}else{ 
			
			if($field_options['default_blank']==1){ $value1 = trim(armainhelper::esc_textarea($field['default_value'])); } 
		
		}
		
		
		//for star rating
		if( $field['type'] == 'scale' ){
			$value1 = ( isset($field['default_value']) and $field['default_value'] != '' ) ? $field['default_value'] : '';
		}
        //for star rating
		
		// for radio and select
		if( $field['type'] == 'radio' || $field['type'] == 'select' ){
			
			$field_options = maybe_unserialize($field['options']);
			
			foreach($field_options as $opt_key => $opt){				
				$field_val = $opt;				
				if(is_array($opt)) {
					$opt = $opt['label'];
					$field_val = ($field_options['separate_value']) ? $field_val['value'] : $opt;
				}				
				if( $field['default_value'] == $field_val )
					$value1 = $field_val;
					
			}
			
		}
		// for radio and select
		
		// for checkbox	
		if( $field['type'] == 'checkbox' ){
			
			$field_options = maybe_unserialize($field['options']);
			
			$default_value = maybe_unserialize($field['default_value']);
			
			foreach($field_options as $opt_key => $opt){				
				$field_val = $opt;
				
				if(is_array($opt)) {
					$opt = $opt['label'];
					$field_val = ($field_options['separate_value']) ? $field_val['value'] : $opt;
				}				
			}
			
			if( $default_value && is_array($default_value) )
			{
				$str_for_check = "[";
				foreach($default_value as $chk_value)
				{
					$value1 = $chk_value;//trim( strtolower($chk_value) );
					$str_for_check .= "'".$value1."', ";			
				}
				$str_for_check = rtrim($str_for_check, ', ');
				$str_for_check .= "]";
				return $str_for_check; 
			} else {
				return "''";
			}
			
		}
		
		// for hidden
		if( $field['type'] == 'hidden' || $field['type'] == 'like' ){
			$value1 = $field['default_value'];	
		}
		
		if( $field['type'] == 'slider' ){
			$field['slider_value'] = isset($field_options['slider_value']) ? $field_options['slider_value'] : '';
			$value1 = ($field['slider_value'] != '') ? $field['slider_value'] :( is_numeric($field_options['minnum']) ? $field_options['minnum'] : 1 ) ;
		}
		
		return "'".$value1."'"; 	
	}
	
	function get_display_style($field=''){
		
		global $wpdb, $MdlDb;		
		$res = $wpdb->get_results($wpdb->prepare("SELECT * FROM ".$MdlDb->fields." WHERE form_id = %d  ORDER BY field_order", $field['form_id']), OBJECT_K);
		$style = '';
		$field['id'] = arfieldhelper::get_actual_id($field['id']);
		
		foreach( $res as $data ){
		
			$data->id = arfieldhelper::get_actual_id($data->id);
			
			if( $field['id'] == $data->id ) {
					
				$conditional_logic = maybe_unserialize($data->conditional_logic);
			
				if( isset($conditional_logic['enable']) and $conditional_logic['enable'] == 1) {
				
					if( count($conditional_logic['rules']) > 0 ) {
						
						$matched = 0;
						$rule_cout = count($conditional_logic['rules']);
						foreach($conditional_logic['rules'] as $val){
							
							foreach( $res as $data_field ){							
								$data_field->id = arfieldhelper::get_actual_id($data_field->id);							
								if( $data_field->id == $val['field_id'] )
									$res_field_send = $data_field;
							}
							if( arfieldhelper::calculate_rule($res_field_send, $val['operator'], $val['value']) )
								$matched++;			
						}
						
						if( ($conditional_logic['if_cond'] == 'all' && $rule_cout == $matched) || ($conditional_logic['if_cond'] == 'any' && $matched > 0) )
							$style = ($conditional_logic['display'] == 'hide') ? 'style="display:none;"' : ''; 
						else 
							$style = ($conditional_logic['display'] == 'show') ? 'style="display:none;"' : '';							 					
					}
				
				}
	
			}
				
		}
		
		
		return $style;
				
	}
	
	function get_display_style_submit( $form )
	{
		$style = '';
		global $wpdb, $MdlDb;
		$res = $wpdb->get_results($wpdb->prepare("SELECT * FROM ".$MdlDb->fields." WHERE form_id = %d  ORDER BY field_order", $form->id), OBJECT_K);
		
		$formoptions = maybe_unserialize($form->options);
		
		/*echo '<pre>';
		print_r( $formoptions );
		echo '</pre>';
		exit;*/
		
		$submit_conditional_logic = $formoptions['submit_conditional_logic'] ? $formoptions['submit_conditional_logic'] : array();
			
		if( isset($submit_conditional_logic['enable']) and $submit_conditional_logic['enable'] == 1) {
		
			if( count($submit_conditional_logic['rules']) > 0 ) {
				
				$matched = 0;
				$rule_cout = count($submit_conditional_logic['rules']);
				foreach($submit_conditional_logic['rules'] as $val){
					
					foreach( $res as $data_field ){							
						$data_field->id = arfieldhelper::get_actual_id($data_field->id);							
						if( $data_field->id == $val['field_id'] )
							$res_field_send = $data_field;
					}
					if( arfieldhelper::calculate_rule($res_field_send, $val['operator'], $val['value']) )
						$matched++;			
				}
				
				if( ($submit_conditional_logic['if_cond'] == 'all' && $rule_cout == $matched) || ($submit_conditional_logic['if_cond'] == 'any' && $matched > 0) )
					$style = ($submit_conditional_logic['display'] == 'hide') ? 'style="display:none;"' : ''; 
				else 
					$style = ($submit_conditional_logic['display'] == 'show') ? 'style="display:none;"' : '';							 					
			}
		
		}
				
		return $style; 
	}
	
	function calculate_rule($field, $operator, $value){
		
		$field = (array)$field;
		
		$value1 = '';		
		$value2 = isset($value) ? $value : '';

		$field_options = maybe_unserialize($field['field_options']);
		$field['default_value'] = isset($field['default_value']) ? $field['default_value'] : '';
		$field_options['default_blank'] = isset($field_options['default_blank']) ? $field_options['default_blank'] : '';
		
		if((isset($field_options['clear_on_focus']) and $field_options['clear_on_focus'] and !empty($field['default_value']))){ 
		
			if($field_options['default_blank']==1){ $value1 = trim(armainhelper::esc_textarea($field['default_value'])); }
				
		}else{ 
			
			if($field_options['default_blank']==1){ $value1 = trim(armainhelper::esc_textarea($field['default_value'])); } 
		
		}
		
		//for star rating
		if( $field['type'] == 'scale' ){
			$value1 = ( isset($field['default_value']) and $field['default_value'] != '' ) ? $field['default_value'] : '';
		}
        //for star rating
		
		// for radio and select
		if( $field['type'] == 'radio' || $field['type'] == 'select' ){
			
			$field_options = maybe_unserialize($field['options']);
			
			foreach($field_options as $opt_key => $opt){				
				$field_val = $opt;				
				if(is_array($opt)) {
					$opt = $opt['label'];
					$field_val = ($field_options['separate_value']) ? $field_val['value'] : $opt;
				}				
				if( $field['default_value'] == $field_val )
					$value1 = $field_val;
					
			}
			
		}
		// for radio and select
		
		// for checkbox	
		if( $field['type'] == 'checkbox' ){
			
			$field_options = maybe_unserialize($field['options']);
			
			$default_value = maybe_unserialize($field['default_value']);
			
			foreach($field_options as $opt_key => $opt){				
				$field_val = $opt;
				
				if(is_array($opt)) {
					$opt = $opt['label'];
					$field_val = ($field_options['separate_value']) ? $field_val['value'] : $opt;
				}				
				//if( armainhelper::check_selected($default_value, $field_val) )
					//$value1 = $field_val;		
			}
			
		}
		
		// for hidden
		if( $field['type'] == 'hidden' || $field['type'] == 'like' ){
			$value1 = $field['default_value'];	
		}
		
		if( $field['type'] == 'slider' ){
			$field['slider_value'] = isset($field_options['slider_value']) ? $field_options['slider_value'] : '';
			$value1 = ($field['slider_value'] != '') ? $field['slider_value'] :( is_numeric($field_options['minnum']) ? $field_options['minnum'] : 1 ) ;	
		}
		
		$value1 = trim( strtolower($value1) );
		
		$value2 = trim( strtolower($value2) );
		
		if( $field['type'] == 'checkbox' ){
			$chk = 0;
			if( $default_value && is_array($default_value) )
			{
				foreach($default_value as $chk_value)
				{
					$value1 = trim( strtolower($chk_value) );		
					if( self::ar_match_rule($value1, $value2, $operator) )
						$chk++;
				}
			}
			
			if($chk > 0) 
				return true; 
			else 
				return false;							
		} else {
			
			return self::ar_match_rule($value1, $value2, $operator);
		}			
	
	}
	
	function ar_match_rule($value1, $value2, $operator)
	{
		// for checkbox
		switch ($operator) {
		
			case 'is':
				return $value1 == $value2;
				break;
				
			case 'is not':
				return $value1 != $value2;
				break;
				
			case 'greater than':
				$value1 = floatval($value1);
				$value2 = floatval($value2);
				
				return $value1 > $value2;
				break;
				
			case 'less than':
				$value1 = floatval($value1);
				$value2 = floatval($value2);
				return $value1 < $value2;  
				break;
			case 'contains':
				if( $value1 != '' && empty($value2) )
					return false;
				else if( empty($value1) && $value2 != '' )
					return false;
				else if( empty($value1) && empty($value2) )
					return true;	
				else if( $value1 != '' && $value2 != '' )
					return ( strpos($value1, $value2) !== FALSE ) ? true : false;  
				break;
				
			case 'not contains':
				if( $value1 != '' && empty($value2) )
					return true;
				else if( empty($value1) && $value2 != '' )
					return true;
				else if( empty($value1) && empty($value2) )
					return false;	
				else if( $value1 != '' && $value2 != '' )
					return ( strpos($value1, $value2) !== FALSE ) ? false : true;  
				break;	
						
		}
		
		return false;
	
	}
	
	//---------- for conditional logic ----------//
	function get_shortcode_modal($form_id, $target_id='content', $type='all', $style=''){ 


        global $arffield, $MdlDb;  


        $field_list = array();


        if(is_numeric($form_id)){


            $exclude = "'divider','captcha','break','html'";


            if($type == 'field_opt')


                $exclude .= ",'data','checkbox'";


            $field_list = $arffield->getAll("fi.type not in (". $exclude .") and fi.form_id=". (int)$form_id, 'field_order');


        }


        $linked_forms = array();

       ?>

      

            <?php if($type != 'field_opt'){ ?>

			
            

            


            <?php }


            if(!empty($field_list)){


            foreach ($field_list as $field){ 


                $field->field_options = maybe_unserialize($field->field_options);


			if($type == 'email')
			{ 
				if($field->type == 'email' || $field->type == 'text')
				{
				?>
            	<div class="modal_field_val" id="arfmodalfieldval_<?php echo $field->ref_field_id;?>" onclick="arfaddcodefornewfield('<?php echo $target_id;?>','<?php echo $field->ref_field_id;?>')"><?php echo $field_name = armainhelper::truncate($field->name, 60).'</div>'; ?>
			<?php
				}	
			}
			else
			{
	        ?>
               <div class="modal_field_val" id="arfmodalfieldval_<?php echo $field->ref_field_id;?>" onclick="arfaddcodefornewfield('<?php echo $target_id;?>','<?php echo $field->ref_field_id;?>')"><?php echo $field_name = armainhelper::truncate($field->name, 60).'</div>'; ?>

                <?php 
			}

            }


            }


            if($type != 'field_opt'){ ?>



            <?php } ?>


    <?php    


    }
	
	function replace_description_shortcode($field){
		$code 	= 'description';
		$value 	= $field['description'];
		
		$html = '[if description]<div class="arf_field_description" [description_style]>[description]</div>[/if description]';
		
		if (!$value or $value == '')
			$html = preg_replace('/(\[if\s+'.$code.'\])(.*?)(\[\/if\s+'.$code.'\])/mis', '', $html);
		else{
			$html = str_replace('[if '.$code.']', '', $html); 
			$html = str_replace('[/if '.$code.']', '', $html);
		}
		$html = str_replace('['.$code.']', $value, $html);			
		
		$description_style = ( isset($field['field_width']) and $field['field_width'] != '' ) ? 'style="width:'.$field['field_width'].'px;"' : '';	
		$html = str_replace('[description_style]', $description_style, $html);			
		
		$html = arformcontroller::arf_remove_br( $html );
		return $html;
	}
	
	function arf_getfields_basic_options_section()
	{
		
		$fieldsbasicoptionsarr = apply_filters('arfavailablefieldsbasicoptions', array(

            'text' => array('isrequired' => 1, 'requiredmsg' => 2, 'fieldsize' => 3, 'customwidth' => 4, 'labelname' => 5, 'fielddescription' => 6, 'placeholdertext' => 7,'cleartextonfocus' => 8, 'validatedefaultvalue' => 9, 'multicolsetting' => 10 ),
            
			'textarea' => array('isrequired' => 1, 'requiredmsg' => 2, 'fieldsize' => 3, 'customwidth' => 4, 'labelname' => 5, 'fielddescription' => 6, 'placeholdertext' => 7, 'cleartextonfocus' => 8, 'validatedefaultvalue' => 9, 'multicolsetting' =>10 ),
			
			'checkbox' => array('isrequired' => 1, 'requiredmsg' => 2, 'alignment' => 3 , /*'usersepratevalues' => 4,*/ 'labelname' => 4, 'fielddescription' => 5, 'multicolsetting' => 6/*, 'field_checkbox_opt' => 8*/ ),
			
			'radio' => array('isrequired' => 1, 'requiredmsg' => 2, 'alignment' => 3 , /*'usersepratevalues' => 4,*/ 'labelname' => 4, 'fielddescription' => 4, 'multicolsetting' => 6/*, 'field_checkbox_opt' => 8*/ ),
			
			'select' => array('isrequired' => 1, 'requiredmsg' => 2, 'customwidth' => 3, /*'validatedefaultvalue' => 4,*/ 'labelname' => 5, 'fielddescription' => 6, /*'usersepratevalues' => 7,*/ 'multicolsetting' => 7/*, 'field_select_opt' => 9*/  ),
			
			'file' => array('isrequired' => 1, 'requiredmsg' => 2, 'customwidth' => 3, 'allowedfiletypes' => 4, 'invalidmessage' => 5, 'attachfiletoemail' => 6, 'uploadbuttonbgcolor' => 7, /*'uploadbuttonfontcolor' => 8,*/ 'uploadbuttontext' => 8, 'removebuttontext' => 9, 'labelname' => 10, 'fielddescription' => 11, 'multicolsetting' => 12),
			
			'email' => array('isrequired' => 1, 'requiredmsg' => 2, 'fieldsize' => 3, 'customwidth' => 4, 'labelname' => 5, 'fielddescription' => 6,  'placeholdertext' => 7, 'cleartextonfocus' => 8,  'invalidmessage' => 9, 'multicolsetting' => 10 ),
			
			'captcha' => array('invalidmessage' => 1, 'labelname' => 2, 'fielddescription' => 3, 'captchastyle' => 4, 'multicolsetting' => 5 ),
            
			'number' => array('isrequired' => 1, 'requiredmsg' => 2, 'fieldsize' => 3, 'customwidth' => 4, 'labelname' => 5, 'fielddescription' => 6, 'placeholdertext' => 7, 'cleartextonfocus' => 8, 'validatedefaultvalue' => 9, 'numberrange' => 10, 'invalidmessage' => 11, 'multicolsetting' => 12 ),
            
			'phone' => array('isrequired' => 1, 'requiredmsg' => 2, 'fieldsize' => 3, 'customwidth' => 4, 'labelname' => 5, 'fielddescription' => 6,'placeholdertext' => 7, 'cleartextonfocus' => 8, 'validatedefaultvalue' => 9, 'phone_validation' => 10, 'invalidmessage' => 11, 'multicolsetting' => 12 ), 
            
			'date' => array('isrequired' => 1, 'requiredmsg' => 2, 'customwidth' => 3, 'calendarlocalization' => 4, 'labelname' => 5, 'fielddescription' => 6, 'placeholdertext' => 7, 'cleartextonfocus' => 8, 'multicolsetting' => 9,  'yearrange' => 10 ), 
            
			'time' => array('isrequired' => 1, 'requiredmsg' => 2, 'customwidth' => 3, 'clocksetting' => 4, 'labelname' => 5, 'fielddescription' => 6, 'multicolsetting' => 7 ),
			
			'url' => array('isrequired' => 1, 'requiredmsg' => 2, 'customwidth' => 3, 'invalidmessage' => 4, 'labelname' => 5, 'fielddescription' => 6,  'placeholdertext' => 7, 'cleartextonfocus' => 8, 'multicolsetting' => 9 ),
            
			'image' => array('isrequired' => 1, 'requiredmsg' => 2, 'customwidth' => 3, 'placeholdertext' => 4, 'labelname' => 5, 'fielddescription' => 6, 'cleartextonfocus' => 7, 'multicolsetting' => 8 ), 
            
			'hidden' => array(), 
            
			'password'  => array('isrequired' => 1, 'requiredmsg' => 2, 'fieldsize' => 3, 'customwidth' => 4,  'labelname' => 5, 'fielddescription' => 6, 'placeholdertext' => 7, 'cleartextonfocus' => 8, 'password_strength'=> 9, 'confirm_password' => 10, 'confirm_password_label' => 11, 'invalid_password' => 12, 'multicolsetting' => 13 ),
            
			'html' => array('htmlcontent' => 1, 'multicolsetting' => 2, 'labelname' => 3 ),
            
			'divider' => array('fontfamilyoption' => 1, 'fontsizeoption' => 2, 'fontstyleoption' => 3, 'bgcoloroption' => 4, 'labelname' => 5, 'fielddescription' => 6, 'multicolsetting' => 7 ),
			
			'break' => array('firstpagelabel' => 1,'secondpagelabel' => 2,'prevbtntext' => 3,'nextbtntext' => 4,'pagebreakstyle' => 5, 'multicolsetting' => 6),					
			
			'scale' => array('isrequired' => 1, 'requiredmsg' => 2, 'starrange' => 3, 'starstyle' => 4, 'labelname' => 5, 'fielddescription' => 6, 'starsize' => 7, 'multicolsetting' => 8 ),
			
			'like' => array('isrequired' => 1, 'requiredmsg' => 2, 'likebtntitle' => 3, 'dislikebtntitle' => 4, 'labelname' => 5, 'fielddescription' => 6, 'likebtnactivecolor' => 7, 'multicolsetting' => 8 ), 
			
			'slider' => array('handletype' => 1,'numberrange' => 2, 'numberofsteps' => 3,  'defaultvalue' => 4, 'labelname' => 5, 'fielddescription' => 6, 'trackbgcolor' => 7, 'handlecolor' => 8, 'multicolsetting' => 9 ), 
		
        ));
		
		return $fieldsbasicoptionsarr;
		
	}
	
	function arf_get_field_option_value($field,$option)
	{
		// for file upload
		$mimes = get_allowed_mime_types(); 
		
		// for captcha
		$is_recaptcha = $field['is_recaptcha']; 
		if($is_recaptcha == '')
			$is_recaptcha = 'recaptcha';
		
		// for calendar
		$locales = array(
                '' => __('English/Western', 'ARForms'), 'af' => __('Afrikaans', 'ARForms'), 
                'sq' => __('Albanian', 'ARForms'), 'ar' => __('Arabic', 'ARForms'), 
                'hy' => __('Armenian', 'ARForms'), 'az' => __('Azerbaijani', 'ARForms'), 
                'eu' => __('Basque', 'ARForms'), 'bs' => __('Bosnian', 'ARForms'), 
                'bg' => __('Bulgarian', 'ARForms'), 'ca' => __('Catalan', 'ARForms'), 
                'zh-HK' => __('Chinese Hong Kong', 'ARForms'), 'zh-CN' => __('Chinese Simplified', 'ARForms'), 
                'zh-TW' => __('Chinese Traditional', 'ARForms'), 'hr' => __('Croatian', 'ARForms'), 
                'cs' => __('Czech', 'ARForms'), 'da' => __('Danish', 'ARForms'), 
                'nl' => __('Dutch', 'ARForms'), 'en-GB' => __('English/UK', 'ARForms'), 
                'eo' => __('Esperanto', 'ARForms'), 'et' => __('Estonian', 'ARForms'), 
                'fo' => __('Faroese', 'ARForms'), 'fa' => __('Farsi/Persian', 'ARForms'), 
                'fi' => __('Finnish', 'ARForms'), 'fr' => __('French', 'ARForms'), 
                'fr-CH' => __('French/Swiss', 'ARForms'), 'de' => __('German', 'ARForms'), 
                'el' => __('Greek', 'ARForms'), 'he' => __('Hebrew', 'ARForms'), 
                'hu' => __('Hungarian', 'ARForms'), 'is' => __('Icelandic', 'ARForms'), 
                'it' => __('Italian', 'ARForms'), 'ja' => __('Japanese', 'ARForms'), 
                'ko' => __('Korean', 'ARForms'), 'lv' => __('Latvian', 'ARForms'), 
                'lt' => __('Lithuanian', 'ARForms'), 'ms' => __('Malaysian', 'ARForms'), 
                'no' => __('Norwegian', 'ARForms'), 'pl' => __('Polish', 'ARForms'), 
                'pt-BR' => __('Portuguese/Brazilian', 'ARForms'), 'ro' => __('Romanian', 'ARForms'), 
                'ru' => __('Russian', 'ARForms'), 'sr' => __('Serbian', 'ARForms'), 
                'sr-SR' => __('Serbian', 'ARForms'), 'sk' => __('Slovak', 'ARForms'), 
                'sl' => __('Slovenian', 'ARForms'), 'es' => __('Spanish', 'ARForms'), 
                'sv' => __('Swedish', 'ARForms'), 'ta' => __('Tamil', 'ARForms'), 
                'th' => __('Thai', 'ARForms'), 'tu' => __('Turkish', 'ARForms'), 
                'uk' => __('Ukrainian', 'ARForms'), 'vi' => __('Vietnamese', 'ARForms') 
            );
		
		// for page break
		$first_break_pre_val = "";
		$first_break_next_val = "";
		
		$first_pre_pg_btn_id = "";
		$first_next_pg_btn_id = "";
		$default_selected_pg_brk_type = "";
		if(isset($_POST['pg_break_pre_first'])) {
			$first_break_pre_val = $_POST['pg_break_pre_first'];
		}
		if(isset($_POST['pg_break_next_first'])) {
			$first_break_next_val = $_POST['pg_break_next_first'];
		}
		
		if(isset($_POST['pg_break_first_select'])) {
			$default_selected_pg_brk_type = $_POST['pg_break_first_select'];
		} else {
			$default_selected_pg_brk_type = $field['page_break_type'];
		}
		
		$first_pre_pg_btn_id = "id='first_pg_break_pre' onblur='save_pg_break_pre_btn_val()'";
		$first_next_pg_btn_id = "id='first_pg_break_next' onblur='save_pg_break_next_btn_val()'";
		$second_page_label_txt = "Second Page Label";
		//$default_selected_pg_brk_type = $field['page_break_type'];

		// for like button
		$like_label = (isset($field['lbllike']) and $field['lbllike'] != '') ? $field['lbllike'] : 'Like';
		$dislike_label = (isset($field['lbldislike']) and $field['lbldislike'] != '') ? $field['lbldislike'] : 'Dislike';
		$like_bg_color = ( $field['like_bg_color'] == '' || $field['like_bg_color'] == '#') ? '#39ABEB' : $field['like_bg_color'];
		$dislike_bg_color = ( $field['dislike_bg_color'] == '' || $field['dislike_bg_color'] == '#') ? '#e00b0b' : $field['dislike_bg_color'];
		
		// for slider
		$slider_left_bg_color = ( $field['slider_bg_color'] == '' || $field['slider_bg_color'] == '#') ? '#d1dee5' : $field['slider_bg_color'];
		$slider_right_bg_color = ( $field['slider_bg_color2'] == '' || $field['slider_bg_color2'] == '#') ? '#bcc7cd' : $field['slider_bg_color2'];
		$slider_handle_color = ( $field['slider_handle_color'] == '' || $field['slider_handle_color'] == '#') ? '#0480BE' : $field['slider_handle_color'];
		$slider_step = is_numeric($field['slider_step']) ? $field['slider_step'] : 1; 
		$field['minnum'] = is_numeric($field['minnum']) ? $field['minnum'] : 1; 
		$field['maxnum'] = is_numeric($field['maxnum']) ? $field['maxnum'] : 50; 
		$field['slider_value'] = is_numeric($field['slider_value']) ? $field['slider_value'] : $field['minnum'];
						
		switch($option)
		{                
	        case 'isrequired':
			?>
				<div style="float:left;">
                <div class="fieldoptions_label_style"><?php _e('Required field', 'ARForms') ?></div>
                <div class="fieldoptions_field_style">
                	<label class="lblswitch"><span>NO&nbsp;</span></label><input type="checkbox" class="js-switch" name="field_options[required_<?php echo $field['id'] ?>]" id="frm_req_field_<?php echo $field['id'] ?>"  <?php echo ($field['required']) ? 'checked="checked"': ''; ?> onchange="arfmakerequiredfieldfunction(<?php echo $field['id'] ?>,<?php echo $field_required = ($field['required'] == '0')? '0' : '1'; ?>,'2')" value="1" /><label class="lblswitch"><span>&nbsp;YES</span></label>
                	<input type="hidden" name="field_options[required_indicator_<?php echo $field['id'] ?>]" value="<?php echo esc_attr($field['required_indicator']); ?>" />
                </div>
                </div>
                
            <?php	  break;
			
			case 'requiredmsg':
			?>
            	
                <div style="float:left;">
                <div class="fieldoptions_label_style"><?php _e('Message for blank field', 'ARForms') ?>:</div>
                <div class="fieldoptions_field_style"><input id="arfrequiredfieldtext<?php echo $field['id'] ?>" type="text" name="field_options[blank_<?php echo $field['id'] ?>]" value="<?php echo esc_attr($field['blank']); ?>" class="arfplacelonginput txtstandardnew arfblank_txt" style="width:210px !important; float:left;" <?php if(!$field['required']) {?> disabled="disabled" <?php }?> /></div> 
            	</div>
                
            <?php	break;
			
			case 'fieldsize':
			?>
				<div style="float:left;">
			 		<div class="fieldoptions_label_style"><?php _e('Field Size', 'ARForms') ?>:</div>
                    <div class="fieldoptions_field_style">
                    <?php if(in_array($field['type'], array('select', 'time', 'data'))){ ?>
                    	<?php if(!isset($values['custom_style']) or $values['custom_style']){ ?>
                        		<input type="checkbox" class="chkstanard" id="frm_auto_width_field_<?php echo $field['id'] ?>" name="field_options[size_<?php echo $field['id'] ?>]" value="1" <?php echo (isset($field['size']) and $field['size'])? 'checked="checked"':''; ?> /><label for="frm_auto_width_field_<?php echo $field['id'] ?>" class="howto"><span></span><?php _e('automatic width', 'ARForms') ?></label>
                        <?php } } else { ?>
                        	<input type="text" style="width:180px;" name="field_options[max_<?php echo $field['id'] ?>]" class="txtstandardnew" value="<?php echo esc_attr($field['max']); ?>" size="5" /><br /> <div class="howto" style="width:180px;"><?php echo ($field['type'] == 'textarea')? __('Number of rows', 'ARForms') : __('characters maximum', 'ARForms') ?></div>
                    <?php }?>	
                    </div>
                    </div>
                
            <?php	  break;
			
			case 'customwidth':
				$field['field_width'] = $field['field_width'] ? $field['field_width'] : '';
			?>
				<div style="float:left;">	
             		<div class="fieldoptions_label_style"><?php _e('Field custom width', 'ARForms') ?>:</div>
                    <div class="fieldoptions_field_style"><div style="float:left"><div style="float:left;"><input id="frm_custom_width_field_<?php echo $field['id'] ?>_div" type="text" style="width:170px;" class="txtstandardnew" name="field_options[field_width_<?php echo $field['id'] ?>]" value="<?php echo esc_attr($field['field_width']); ?>" /></div><div style="padding-top:5px; float:left;">&nbsp;px</div></div>
                    <?php if($field['type'] == 'text' || $field['type'] == 'textarea' || $field['type'] == 'password')
					{ ?><div class="howto" style="width:160px;float:left">&nbsp;</div>
                    <?php } ?>
                    </div>
             </div>
                
            <?php	  break;
			
			case 'cleartextonfocus':
			?>
				<div style="float:left;">
						<div class="fieldoptions_label_style"><?php _e('Clear Default Text on Focus', 'ARForms') ?></div>
						<div class="fieldoptions_field_style">
                            <label class="lblswitch"><span>NO&nbsp;</span></label><input type="checkbox" class="js-switch" name="field_options[frm_clear_field_<?php echo $field['id'] ?>]" id="frm_clear_field_<?php echo $field['id'] ?>"  <?php echo ($field['clear_on_focus']) ? 'checked="checked"': ''; ?> onchange="arfcleardefaultvalueonfocus(<?php echo $field['id'] ?>,<?php echo $field['clear_on_focus'];?>,2)" value="1" /><label class="lblswitch"><span>&nbsp;YES</span></label>
                            <input type="hidden" name="field_options[frm_clear_field_indicator_<?php echo $field['id'] ?>]" value="<?php $field['frm_clear_field_indicator'] = isset($field['frm_clear_field_indicator']) ? $field['frm_clear_field_indicator'] : ''; echo esc_attr($field['frm_clear_field_indicator']); ?>" />
						</div>
				   </div>
                
            <?php	  break;
			
			case 'validatedefaultvalue':
			?>
				<div style="float:left;">
						<div class="fieldoptions_label_style"><?php _e('Validate default value', 'ARForms') ?></div>
                    	<div class="fieldoptions_field_style">
                        <label class="lblswitch"><span>NO&nbsp;</span></label><input type="checkbox" class="js-switch" name="field_options[frm_default_blank_<?php echo $field['id'] ?>]" id="frm_default_blank_<?php echo $field['id'] ?>"  <?php echo ($field['default_blank']) ? 'checked="checked"': ''; ?> onchange="arfdefaultblank(<?php echo $field['id'] ?>,<?php echo $field['default_blank'];?>,2)" value="1" /><label class="lblswitch"><span>&nbsp;YES</span></label>
                        <input type="hidden" name="field_options[frm_default_blank_indicator_<?php echo $field['id'] ?>]" value="<?php $field['frm_default_blank_indicator'] = isset($field['frm_default_blank_indicator']) ? $field['frm_default_blank_indicator'] : ''; echo esc_attr($field['frm_default_blank_indicator']); ?>" />
                    </div>
				   </div>
                
            <?php	  break;
			
			case 'multicolsetting':
				
			$field['classes'] = ( ! isset($field['classes']) || empty($field['classes']) ) ? 'arf_1' : $field['classes'];
			?>
				<div style="float:left;">
             		<div class="fieldoptions_label_style"><?php _e('Columns', 'ARForms') ?>:</div>
                    <div class="fieldoptions_field_style">
                         <div style="float:left; padding-top:5px;"><div class="multi_column_div"><input type="radio" onclick="CheckFieldPos('1','0');" class="rdostandard multicolfield" name="field_options[classes_<?php echo $field['id'] ?>]" data-id="<?php echo $field['id']; ?>" id="classes_<?php echo $field['id'] ?>_1" value="arf_1" <?php armainhelper::checked($field['classes'], 'arf_1'); ?> /><label for="classes_<?php echo $field['id'] ?>_1"><span class="lblsubtitle_span_column"></span><div class="api_lable_column arf_one_column"><?php /*?><br /><br /><label class="arf_coulmn_title"><?php _e('One', 'ARForms') ?></label><?php */?></div></label>
        <input type="radio" class="rdostandard multicolfield" name="field_options[classes_<?php echo $field['id'] ?>]" onclick="CheckFieldPos('1','0');" id="classes_<?php echo $field['id'] ?>_2" value="arf_2" data-id="<?php echo $field['id']; ?>" <?php armainhelper::checked($field['classes'], 'arf_2'); ?> /><label for="classes_<?php echo $field['id'] ?>_2"><span class="lblsubtitle_span_column"></span><div class="api_lable_column arf_two_column"><?php /*?><br /><br /><label class="arf_coulmn_title"><?php _e('Two', 'ARForms') ?></label><?php */?></div></label>
        <input type="radio" class="rdostandard multicolfield" name="field_options[classes_<?php echo $field['id'] ?>]" onclick="CheckFieldPos('1','0');" id="classes_<?php echo $field['id'] ?>_3" value="arf_3" data-id="<?php echo $field['id']; ?>" <?php armainhelper::checked($field['classes'], 'arf_3'); ?> /><label for="classes_<?php echo $field['id'] ?>_3"><span class="lblsubtitle_span_column"></span><div class="api_lable_column arf_three_column"><?php /*?><br /><br /><label class="arf_coulmn_title"><?php _e('Three', 'ARForms') ?></label><?php */?></div></label></div>
                         
                         </div>
                    </div>
             </div>
                
            <?php	  break;
			
			case 'alignment':
			?>
				<div style="float:left;">  	
                     <div class="fieldoptions_label_style"><?php _e('Alignment', 'ARForms') ?>:</div>
                     
                     <div class="fieldoptions_field_style">
                     	<div class="sltstandard" style="float:none;">
                    
                            <select onchange="arfchangefieldalign('<?php echo $field['id'] ?>');" id="arf_field_align_<?php echo $field['id'];?>" name="field_options[align_<?php echo $field['id'] ?>]" style="width:180px;" data-width="180px">
                                <option value="block" <?php selected($field['align'], 'block') ?>><?php _e('Multiple Rows', 'ARForms'); ?></option>
                                <option value="inline" <?php selected($field['align'], 'inline') ?>><?php _e('Single Row', 'ARForms'); ?></option>
                            </select>
            
                    	</div>
                     </div>
           		 </div>
                
            <?php	  break;
			
			case 'usersepratevalues':
			?>
				<div style="float:left;">
                 <div class="fieldoptions_label_style"><?php _e('Use separate values', 'ARForms'); ?>:</div>	
                 <div class="fieldoptions_field_style">
                
                <label class="lblswitch">&nbsp;&nbsp;<span>NO&nbsp;</span></label><input type="checkbox" class="js-switch" name="field_options[separate_value_<?php echo $field['id'] ?>]" id="separate_value_<?php echo $field['id'] ?>"  <?php echo ($field['separate_value']) ? 'checked="checked"': ''; ?> onchange="arfplaceseparatevalue(<?php echo $field['id'] ?>)" value="1" /><label class="lblswitch"><span>&nbsp;YES</span></label><span style="margin-left:10px;"><img src="<?php echo ARFIMAGESURL ?>/tooltips-icon.png" alt="?" class="arfhelptip" title="<?php _e('Add a separate value to use for calculations, email routing, saving to the database, and many other uses. The option values are saved while the option labels are shown in the form.', 'ARForms') ?>" align="absmiddle" /></span>
              
                </div>
            	</div>
                
            <?php	  break;
			
			case 'allowedfiletypes':
				
				if($mimes){ ?>
                    <div style="float:left;">
                    <div class="fieldoptions_label_style"><?php _e('Allowed file types', 'ARForms') ?>:<span style="margin-left:10px;"><img src="<?php echo ARFIMAGESURL ?>/tooltips-icon.png" alt="?" class="arfhelptip" title="<?php _e('All types allow only wordpress default file types.', 'ARForms') ?>" align="absmiddle" /></span></div>
                    <div class="fieldoptions_field_style"><input type="radio" class="rdostandard" name="field_options[restrict_<?php echo $field['id'] ?>]" id="restrict_<?php echo $field['id'] ?>_0" value="0" <?php armainhelper::checked($field['restrict'], 0); ?> onclick="arfshowconditionaldiv('restrict_box_<?php echo $field['id'] ?>',this.value,1,'.')" /> <label for="restrict_<?php echo $field['id'] ?>_0"><span></span><?php _e('All types', 'ARForms') ?></label>&nbsp;<input type="radio" class="rdostandard" name="field_options[restrict_<?php echo $field['id'] ?>]" id="restrict_<?php echo $field['id'] ?>_1" value="1" <?php armainhelper::checked($field['restrict'], 1); ?> onclick="arfshowconditionaldiv('restrict_box_<?php echo $field['id'] ?>',this.value,1,'.')" /> <label for="restrict_<?php echo $field['id'] ?>_1"><span></span><?php _e('Specify types', 'ARForms') ?></label></div>
                    <div style="float:left; width:380px; font-size:14px;">
                    <span class="restrict_box_<?php echo $field['id'] ?>" <?php echo ($field['restrict'] == 1) ? '' : 'style="display:none"'; ?>>
            
            
                        <label for="check_all_ftypes_<?php echo $field['id'] ?>"></label>
                            
            
                        </span>
            
            
                        <div style="position:absolute;z-index:101; background-color:#f4f4f4; border: 1px solid #BCC4CC; padding:10px 10px 15px 15px; display:none;" class="restrict_box_<?php echo $field['id'] ?>" >
                        <div class="cose" style="float:right">
                            <button data-dismiss="arfmodal" class="close" onclick="arfclosefileallowed('restrict_box_<?php echo $field['id'] ?>', '0');" type="button" style="margin-top:-12px; margin-right:-3px;">x</button>
                        </div>
                        
                        <div class="main_allowed_types">
            
                        <div class="arffieldoptionslist" style="width:650px;">
            
            
                            <div class="alignleft" style="width:99% !important">
            
            
                                <?php 
                                ksort($mimes);
                                
                                $mcount = count($mimes);
            
            
                                $third = ceil($mcount/3);
            
            
                                $c = 0;
            
                                $mimes['exe'] = '';
                                unset($mimes['exe']);
                                
                                foreach($mimes as $ext_preg => $mime){ 
            
            
                                    if($c == $third or (($c/2) == $third)){} ?>
            
            
                                <div style=" width:30%; margin-top:3px; margin-left:5px; float:left;"><input type="checkbox" class="chkstanard" id="field_options[ftypes_<?php echo $field['id'] ?>][<?php echo $ext_preg ?>]" name="field_options[ftypes_<?php echo $field['id'] ?>][<?php echo $ext_preg ?>]" value="<?php echo $mime ?>" <?php if(isset($field['ftypes']) and !empty($field['ftypes'])) armainhelper::checked($field['ftypes'], $mime); ?> /><label for="field_options[ftypes_<?php echo $field['id'] ?>][<?php echo $ext_preg ?>]" class="howto"><span></span><?php echo str_replace('|', ', ', $ext_preg); ?></label>
                                </div>
            
            
                                <?php 
            
            
                                    $c++;
            
            
                                    unset($ext_preg);
            
            
                                    unset($mime);
            
            
                                } 
            
            
                                unset($c);
            
            
                                unset($mcount);
            
            
                                unset($third);
            
            
                                ?>
            
            
                            </div>
            
            
                        </div>
                        
                        </div>	<!-- end allowed type -->	
            
                        </div>
                        <div class="clear"></div>
                    </div>
                    </div>
                 <?php }?>
                
            <?php	  break;
			
			case 'invalidmessage':
			?>
				<div style="float:left;">
                        <div class="fieldoptions_label_style"><?php _e('Message for invalid submission', 'ARForms') ?>:</div>
                        <div class="fieldoptions_field_style"><input type="text" name="field_options[invalid_<?php echo $field['id'] ?>]" class="txtstandardnew arfplacelonginput" value="<?php echo esc_attr($field['invalid']); ?>" style="width:210px !important; float:left;" /></div>
                    </div>
                
            <?php	  break;
			
			case 'attachfiletoemail':
			?>
				<div style="float:left;" class="emailattachwidth">
            <div class="fieldoptions_label_style"><?php _e('Attach file with email', 'ARForms') ?>:</div>
            <div class="fieldoptions_field_style"><label class="lblswitch"><span>NO&nbsp;</span></label><input type="checkbox" class="js-switch" name="field_options[attach_<?php echo $field['id'] ?>]" id="field_options[attach_<?php echo $field['id'] ?>]"  <?php echo (isset($field['attach']) and $field['attach'])? 'checked="checked"':''; ?> value="1" /><label class="lblswitch"><span>&nbsp;YES</span></label></div>
            </div>
                
            <?php	  break;
			
			case 'uploadbuttonbgcolor':
			$upload_btn_color = ($field['upload_btn_color'] == '' || $field['upload_btn_color'] == '#') ? '#077bdd' : $field['upload_btn_color'];
			$upload_font_color= ($field['upload_font_color'] == '' || $field['upload_font_color'] == '#') ? '#ffffff' : $field['upload_font_color'];
			?>
		        <div style="float:left;">
        <div class="fieldoptions_label_style"><?php _e('Upload color', 'ARForms') ?>:</div>

        <div class="fieldoptions_field_style">
        	
            <div style="float:left; width:60px; font-size:14px;">
                <div class="arf_coloroption_sub">
                    <div class="arf_coloroption arfhex" data-fid="upload_btn_color_<?php echo $field['id'] ?>" style="background:<?php echo esc_attr($upload_btn_color); ?>;"></div>
                    <div class="arf_coloroption_subarrow_bg">
                        <div class="arf_coloroption_subarrow"></div>
                    </div>
                </div>
                <input type="hidden" name="field_options[upload_btn_color_<?php echo $field['id'] ?>]" id="upload_btn_color_<?php echo $field['id'] ?>" class="hex txtstandardnew" value="<?php echo esc_attr($upload_btn_color); ?>" style="width:90px;" />
                <span class="howto" style="padding-left:0px;float:left; margin-top: 2px;"><?php _e('Button', 'ARForms');?></span>
            </div>
            <div style="float:left; width:50px; margin-left:15px; font-size:14px;">
            	<div class="arf_coloroption_sub">
                        <div class="arf_coloroption arfhex" data-fid="upload_font_color_<?php echo $field['id'] ?>" style="background:<?php echo esc_attr($upload_font_color); ?>;"></div>
                        <div class="arf_coloroption_subarrow_bg">
                            <div class="arf_coloroption_subarrow"></div>
                        </div>
                    </div>
                    <input type="hidden" name="field_options[upload_font_color_<?php echo $field['id'] ?>]" id="upload_font_color_<?php echo $field['id'] ?>" class="hex txtstandardnew" value="<?php echo esc_attr($upload_font_color); ?>" style="width:90px;" />
                    <span class="howto" style="padding-left:0px;float:left; margin-top: 2px;"><?php _e('Font', 'ARForms');?></span>
            </div>
            
            </div>
        </div>
        
        	<?php	  break;
			
			case 'uploadbuttonfontcolor':
			?>
		        <div style="float:left;">
                    <div class="fieldoptions_label_style"><?php _e('Upload font color', 'ARForms') ?>:</div>
                    <?php $upload_font_color = ($field['upload_font_color'] == '' || $field['upload_font_color'] == '#') ? '#ffffff' : $field['upload_font_color']; ?>
                    <div class="fieldoptions_field_style">
                    	
                    <div class="arf_coloroption_sub">
                        <div class="arf_coloroption arfhex" data-fid="upload_font_color_<?php echo $field['id'] ?>" style="background:<?php echo esc_attr($upload_font_color); ?>;"></div>
                        <div class="arf_coloroption_subarrow_bg">
                            <div class="arf_coloroption_subarrow"></div>
                        </div>
                    </div>
                    <input type="hidden" name="field_options[upload_font_color_<?php echo $field['id'] ?>]" id="upload_font_color_<?php echo $field['id'] ?>" class="hex txtstandardnew" value="<?php echo esc_attr($upload_font_color); ?>" style="width:90px;" /></div>
                </div>
        
        	<?php	  break;
			
			case 'uploadbuttontext':
			?>
		        <div style="float:left;">
        <div class="fieldoptions_label_style"><?php _e('Upload button text', 'ARForms') ?>:</div>
        <?php $file_upload_text = ($field['file_upload_text'] == '') ? 'Upload' : $field['file_upload_text']; ?>
        <div class="fieldoptions_field_style"><input type="text" name="field_options[file_upload_text_<?php echo $field['id'] ?>]" class="txtstandardnew" value="<?php echo esc_attr($file_upload_text); ?>" style="width:210px;" /></div>
        </div>
        
        	<?php	  break;
			
			case 'removebuttontext':
			?>
		        <div style="float:left;">
        <div class="fieldoptions_label_style"><?php _e('Remove Button text', 'ARForms') ?>:</div>
        <?php $file_remove_text = ($field['file_remove_text'] == '') ? 'Remove' : $field['file_remove_text']; ?>
        <div class="fieldoptions_field_style"><input type="text" name="field_options[file_remove_text_<?php echo $field['id'] ?>]" class="txtstandardnew" value="<?php echo esc_attr($file_remove_text); ?>" style="width:210px;" /></div>
        </div>
        
        	<?php	  break;
			
			case 'captchastyle':
			?>
            
					<div style="float:left;">
		<div class="fieldoptions_label_style"><?php _e('Select captcha', 'ARForms') ?>:</div>
		<div class="fieldoptions_field_style">
		<select name="field_options[is_recaptcha_<?php echo $field['id'];?>]" id="is_recaptcha-<?php echo $field['id'];?>" class="frm-bulk-select-class" onchange="changerecaptchaimage('<?php echo $field['id'];?>',this.value, '<?php echo $field['id'];?>')" data-width="150px">
			<option value="recaptcha" <?php selected($is_recaptcha, 'recaptcha') ?>>Recaptcha</option>
			<option value="custom-captcha" <?php selected($is_recaptcha, 'custom-captcha') ?>>Default captcha</option>
		</select>
		</div>
        </div>
        
        	<?php	  break;
			
			case 'numberrange':
			?>
		        <div style="float:left; width:100%;">
                    <div class="fieldoptions_label_style"><?php _e('Number Range', 'ARForms') ?>:</div>
                    <div class="fieldoptions_field_style"><div style="float:left; padding-right:10px;"><input type="text" name="field_options[minnum_<?php echo $field['id'] ?>]" class="txtstandardnew" value="<?php echo esc_attr($field['minnum']); ?>" size="5" /><br /><span class="howto"><?php echo _e('minimum', 'ARForms') ?></span></div><div><input type="text" name="field_options[maxnum_<?php echo $field['id'] ?>]" class="txtstandardnew" value="<?php echo esc_attr($field['maxnum']); ?>" size="5" /><br /><span class="howto"><?php _e('maximum', 'ARForms') ?></span></div></div>
                    </div>
        
        	<?php	  break;
			
			case 'calendarlocalization':
			?>
		        <div style="float:left;">	
                <div class="fieldoptions_label_style"><?php _e('Calendar Localization', 'ARForms') ?></div>
                <div class="fieldoptions_field_style"><div class="sltstandard" style="float:none;">
        
                <select name="field_options[locale_<?php echo $field['id'] ?>]" style="width:180px;" data-width="180px" data-size="15">
            
            
                    <?php foreach($locales as $locale_key => $locale){
            
            
                        $selected = (isset($field['locale']) && $field['locale'] == $locale_key)? ' selected="selected"':''; ?>
            
            
                        <option value="<?php echo $locale_key ?>"<?php echo $selected; ?>><?php echo $locale ?></option>
            
            
                    <?php } ?>
            
            
                </select>
            
                </div></div>
                </div>
        
        	<?php	  break;
			
			case 'yearrange':
			?>
		        <div style="float:left;">
                <div class="fieldoptions_label_style"><?php _e('Year Range', 'ARForms') ?>:</div>
                <div class="fieldoptions_field_style fieldoptions_labelstyle"><div class="lblswitch" style="float:left"><span><?php _e('Start Year', 'ARForms') ?>:&nbsp;</span><input type="text" name="field_options[start_year_<?php echo $field['id'] ?>]" class="txtstandardnew" value="<?php echo isset($field['start_year']) ? $field['start_year'] : ''; ?>" size="4"/></div><div class="lblswitch" style="float:left; padding-left:6px;"><span><?php _e('End Year', 'ARForms') ?>:&nbsp;</span><input type="text" name="field_options[end_year_<?php echo $field['id'] ?>]" class="txtstandardnew" value="<?php echo isset($field['end_year']) ? $field['end_year'] : ''; ?>" size="4"/></div></div>
            </div>
        
        	<?php	  break;
			
			case 'clocksetting':
			?>
		        <div style="float:left;">	
                    <div class="fieldoptions_label_style"><?php _e('Clock Settings', 'ARForms') ?>:</div>
                    <div class="fieldoptions_field_style">
                    <div style="width:90px; font-size:14px; float:left;"><div class="sltstandard" style="float:left;">
                    
                    <select name="field_options[clock_<?php echo $field['id'] ?>]" style="width:70px;" data-width="70px">
                        <option value="12" <?php selected($field['clock'], 12) ?>>12</option>
                        <option value="24" <?php selected($field['clock'], 24) ?>>24</option>
                    </select> </div> <span class="howto" style="padding-left:0px;float:left;"><?php _e('hour', 'ARForms') ?></span></div>
                    <div style="float:left; width:92px; font-size:14px;">
                    
                    <div class="sltstandard" style="float:left;"><select name="field_options[step_<?php echo $field['id'] ?>]" id="time_step_<?php echo $field['id'] ?>"  style=" width:70px;" data-width="70px">
                        <option value="1" <?php selected($field['step'], 1);?>>1</option>
                        <option value="2" <?php selected($field['step'], 2);?>>2</option>
                        <option value="3" <?php selected($field['step'], 3);?>>3</option>
                        <option value="4" <?php selected($field['step'], 4);?>>4</option>
                        <option value="5" <?php selected($field['step'], 5);?>>5</option>
                        <option value="10" <?php selected($field['step'], 10);?>>10</option>
                        <option value="15" <?php selected($field['step'], 15);?>>15</option>
                        <option value="20" <?php selected($field['step'], 20);?>>20</option>
                        <option value="25" <?php selected($field['step'], 25);?>>25</option>
                        <option value="30" <?php selected($field['step'], 30);?>>30</option>
                    </select>
                    </div>
                    <br /><div class="howto" style="padding-right:10px; margin-top:5px;"><?php _e('minute', 'ARForms') ?></div> </div>
                    </div>
                    </div>
        
        	<?php	  break;
			
			case 'htmlcontent':
			?>
				<div style="float:left; width:100%;">
					<div class="fieldoptions_label_style"><?php _e('Content', 'ARForms') ?></div>
        <div class="fieldoptions_field_style fieldoptions_htmlfield"><textarea name="field_options[description_<?php echo $field['id'] ?>]" class="txtmultinew" style="width:98%;" rows="8"><?php echo armainhelper::esc_textarea($field['description']) ?></textarea></div>
        <div style="font-size:14px; padding:5px 5px 5px 15px;">[ <?php _e('Embedded tags for youtube, map etc are supported.', 'ARForms');?> ]</div>
                 </div>
                
            <?php	  break;
			
			case 'fontfamilyoption':
			?>
				<div style="float:left;">
                    <div class="fieldoptions_label_style"><?php _e('Font Family', 'ARForms') ?></div>
                    <div class="fieldoptions_field_style">
                         <div style="float:left;">
                            <div class="sltstandard" style="float:right; margin-left:0px; margin-bottom:10px; ">
                                <?php $get_googlefonts_data = arformcontroller::get_arf_google_fonts(); ?>
                                <select name="field_options[arf_divider_font_<?php echo $field['id'] ?>]" style="width:200px;" data-width='200px' data-size='15'>	
            						<optgroup label="Default Fonts">
                                        <option value="Arial" <?php selected($field['arf_divider_font'], 'Arial') ?>>Arial</option>
                                        <option value="Helvetica" <?php selected($field['arf_divider_font'], 'Helvetica') ?>>Helvetica</option>
                                        <option value="sans-serif" <?php selected($field['arf_divider_font'], 'sans-serif') ?>>sans-serif</option>
                                        <option value="Lucida Grande" <?php selected($field['arf_divider_font'], 'Lucida Grande') ?>>Lucida Grande</option>
                                        <option value="Lucida Sans Unicode" <?php selected($field['arf_divider_font'], 'Lucida Sans Unicode') ?>>Lucida Sans Unicode</option>
                                        <option value="Tahoma" <?php selected($field['arf_divider_font'], 'Tahoma') ?>>Tahoma</option>
                                        <option value="Times New Roman" <?php selected($field['arf_divider_font'], 'Times New Roman') ?>>Times New Roman</option>
                                        <option value="Courier New" <?php selected($field['arf_divider_font'], 'Courier New') ?>>Courier New</option>
                                        <option value="Verdana" <?php selected($field['arf_divider_font'], 'Verdana') ?>>Verdana</option>
                                        <option value="Geneva" <?php selected($field['arf_divider_font'], 'Geneva') ?>>Geneva</option>
                                        <option value="Courier" <?php selected($field['arf_divider_font'], 'Courier') ?>>Courier</option>
                                        <option value="Monospace" <?php selected($field['arf_divider_font'], 'Monospace') ?>>Monospace</option>
                                        <option value="Times" <?php selected($field['arf_divider_font'], 'Times') ?>>Times</option>
            						</optgroup>
                                    <optgroup label="Google Fonts">
                                    	<?php
											if(count($get_googlefonts_data)>0) {
												foreach($get_googlefonts_data as $goglefontsfamily)
												{
													echo "<option value='".$goglefontsfamily."' ".selected($field['arf_divider_font'], $goglefontsfamily)." >".$goglefontsfamily."</option>";
												}
											}
										?>
                                    </optgroup>
                                </select>
                                </div> 
                        </div>
                    </div>
                 </div>
                
            <?php	  break;
			
			case 'fontsizeoption':
			?>
				<div style="float:left;">
                    <div class="fieldoptions_label_style"><?php _e('Font Size', 'ARForms') ?></div>
                    <div class="fieldoptions_field_style">
                         <div style="float:left;">
                            <div class="sltstandard" style="float:left;">
                            <select name="field_options[arf_divider_font_size_<?php echo $field['id'] ?>]" style="width:180px;" data-width='180px' data-size='15'>	
								<?php for($i = 8; $i <= 20; $i ++ ) { ?>
                                <option value="<?php echo $i?>" <?php selected($field['arf_divider_font_size'], $i) ?>><?php _e($i, 'ARForms') ?></option>
                                <?php } ?>
                                <?php for($i = 22; $i <= 28; $i=$i+2 ) { ?>
                                <option value="<?php echo $i?>" <?php selected($field['arf_divider_font_size'], $i) ?>><?php _e($i, 'ARForms') ?></option>
                                <?php } ?>
                                <?php for($i = 32; $i <= 40; $i=$i+4 ) { ?>
                                <option value="<?php echo $i?>" <?php selected($field['arf_divider_font_size'], $i) ?>><?php _e($i, 'ARForms') ?></option>
                                <?php } ?>
                            </select>
                            </div>
                            &nbsp;<span class="arf_px" style="float:right; padding-top:5px;"><?php _e('px', 'ARForms') ?></span> 
                        </div>
                    </div>
                 </div>
                
            <?php	  break;
			
			case 'fontstyleoption':
			?>
				<div style="float:left;">
                    <div class="fieldoptions_label_style"><?php _e('Font Style', 'ARForms') ?></div>
                    <div class="fieldoptions_field_style">
                         <div style="float:left;">
                           <div class="sltstandard" style="float:right; margin-right:17px;">
                            <select name="field_options[arf_divider_font_style_<?php echo $field['id'] ?>]" style="width:180px;" data-width='180px'>
                            <option value="normal" <?php selected($field['arf_divider_font_style'], 'normal') ?>><?php _e('normal', 'ARForms') ?></option>
                            <option value="bold" <?php selected($field['arf_divider_font_style'], 'bold') ?>><?php _e('bold', 'ARForms') ?></option>
                            <option value="italic" <?php selected($field['arf_divider_font_style'], 'italic') ?>><?php _e('italic', 'ARForms') ?></option>
                            </select>
                                </div>
                        </div>
                    </div>
                 </div>
                
            <?php	  break;
			
			case 'bgcoloroption':
			?>
				<?php /*?><style type="text/css">
				 #field-option-<?php echo $field['id'] ?> #picker { left:auto; }
                 </style><?php */?>
                 <div style="float:left;">
                    <div class="fieldoptions_label_style"><?php _e('Background Color', 'ARForms') ?></div>
                    <div class="fieldoptions_field_style">
                         <div style="float:left;">
                           <?php $arf_divider_bg_color = ($field['arf_divider_bg_color'] == '' || $field['arf_divider_bg_color'] == '#') ? '#ffffff' : $field['arf_divider_bg_color']; ?>
                           <div class="arf_coloroption_sub">
                                <div class="arf_coloroption arfhex" data-fid="arf_divider_bg_color_<?php echo $field['id'] ?>" style="background:<?php echo $arf_divider_bg_color; ?>;"></div>
                                <div class="arf_coloroption_subarrow_bg">
                                    <div class="arf_coloroption_subarrow"></div>
                                </div>
                            </div>	
                           <input type="hidden" name="field_options[arf_divider_bg_color_<?php echo $field['id'] ?>]" id="arf_divider_bg_color_<?php echo $field['id'] ?>" class="hex txtstandardnew" value="<?php echo $arf_divider_bg_color; ?>" style="width:90px;" />
                        </div>
                    </div>
                 </div>
                
            <?php	  break;
			
			case 'firstpagelabel':
				
				global $MdlDb;
                $page_num = $MdlDb->get_count($MdlDb->fields, array("form_id" => $field['form_id'], "type" => 'break'));
				$second_page_label_txt = "Page Label";
				if($page_num==1 || $field['page_break_first_use']==1)
				{
		?>
			<div style="float:left;" id="pg_break_div_<?php echo $field['id'] ?>" class="pg-break-div">
                <div class="fieldoptions_label_style"><?php _e('First Page Label', 'ARForms') ?></div>
                
                <div class="fieldoptions_field_style">
                     <div style="float:left;">
    					 <input type="text" id="field_options[first_page_label_<?php echo $field['id'] ?>]" name="field_options[first_page_label_<?php echo $field['id'] ?>]" class="txtstandardnew" value="<?php echo ( isset($field['first_page_label']) and $field['first_page_label'] != '' ) ? esc_attr($field['first_page_label']) : 'Step1'; ?>" size="10" style="width:180px;" />
                         <input type="hidden" id="page_break_first_use_<?php echo $field['id'] ?>" name="field_options[page_break_first_use_<?php echo $field['id'] ?>]" value="1" /><br />
                         <input type="hidden" name="page_number_<?php echo $field['id'] ?>" class="pagebreak_field" value="<?php echo $field['id']; ?>" id="page_number_<?php echo $field['id'] ?>" /> 
				    </div>
                </div>
             </div>
             
       <?php } else { ?>
			<div style="float:left;" id="pg_break_div_<?php echo $field['id'] ?>" class="pg-break-div">
                <div class="fieldoptions_label_style"><?php _e('First Page Label', 'ARForms') ?></div>
                <div class="fieldoptions_field_style">
                     <div style="float:left;">
    					 <input type="text" id="field_options[first_page_label_<?php echo $field['id'] ?>]" name="field_options[first_page_label_<?php echo $field['id'] ?>]" class="txtstandardnew" value="<?php echo ( isset($field['first_page_label']) and $field['first_page_label'] != '' ) ? esc_attr($field['first_page_label']) : 'Step1'; ?>" size="10" style="width:180px;" />
                        <input type="hidden" id="page_break_first_use_<?php echo $field['id'] ?>" name="field_options[page_break_first_use_<?php echo $field['id'] ?>]" value="0" /><br />
                        <input type="hidden" name="page_number_<?php echo $field['id']; ?>" class="pagebreak_field" value="<?php echo $field['id']; ?>" id="page_number_<?php echo $field['id']; ?>" /> 
				    </div>
                </div>
             </div>       
	   <?php } ?>
                
            <?php	  break;
			
			case 'secondpagelabel':
			?>
				<div style="float:left;">
                <div class="fieldoptions_label_style"><?php _e($second_page_label_txt, 'ARForms') ?></div>
                <div class="fieldoptions_field_style">
                     <div style="float:left;">
    					<input type="text" id="field_options[second_page_label_<?php echo $field['id'] ?>]" name="field_options[second_page_label_<?php echo $field['id'] ?>]" class="txtstandardnew" value="<?php echo ( isset($field['second_page_label']) and $field['second_page_label'] != '' ) ? esc_attr($field['second_page_label']) : 'Step2'; ?>" size="10" style="width:180px;" /><br /> 
				    </div>
                </div>
             </div>
                
            <?php	  break;
			
			case 'prevbtntext':
			?>
				<div style="float:left;">
                    <div class="fieldoptions_label_style"><?php _e('Previous Button Text', 'ARForms') ?></div>
                    
                    <div class="fieldoptions_field_style">
                         <div style="float:left">
                            <?php 
                            if($first_break_pre_val=="") { 
                                $pre_page_title = esc_attr($field['pre_page_title']);
                            }else {
                                $pre_page_title = esc_attr($first_break_pre_val);
                            }
                            ?>
                            <input type="text" <?php echo $first_pre_pg_btn_id;?> name="field_options[pre_page_title_<?php echo $field['id'] ?>]" class="txtstandardnew" value="<?php echo ( isset($pre_page_title) and $pre_page_title != '' ) ? $pre_page_title : 'Previous'; ?>" size="10" style="width:180px;" /><br /> 
                        </div>
                    </div>
             	</div>
                
            <?php	  break;
			

			case 'nextbtntext':
			?>
				<div style="float:left;">
                <div class="fieldoptions_label_style"><?php _e('Next Button Text', 'ARForms') ?></div>
                
                <div class="fieldoptions_field_style">
					<div style="float:left">
                    	<?php
                    	if($first_break_next_val=="") { 
                        	$next_page_title = esc_attr($field['next_page_title']);
                        }else {
							$next_page_title = esc_attr($first_break_next_val);
						}
						?>
                   		<input type="text" <?php echo $first_next_pg_btn_id;?> name="field_options[next_page_title_<?php echo $field['id'] ?>]" class="txtstandardnew" value="<?php echo ( isset($next_page_title) and $next_page_title !='' ) ? $next_page_title : 'Next'; ?>" size="10" style="width:180px;" /><br />
                        <?php 
							$first_next_pg_btn_id="";
							$first_pre_pg_btn_id="";
						?> 
                	</div>
                </div>
             </div>
                
            <?php	  break;
			
			case 'pagebreakstyle':
			?>
				<div style="float:left;">
                <div class="fieldoptions_label_style"><?php _e('Style', 'ARForms') ?></div>
                <div class="fieldoptions_field_style">
					<div style="float:left">
                    	<div class="sltstandard" style="float:left;">
                           <select class="page_break_select" onchange="change_page_break_select(this.value);" name="field_options[page_break_type_<?php echo $field['id'] ?>]" style="width:180px;" data-width="180px">
                
                            <option value="wizard" <?php selected($default_selected_pg_brk_type, 'wizard') ?>><?php _e('Wizard', 'ARForms') ?></option>
                
                            <option value="survey" <?php selected($default_selected_pg_brk_type, 'survey') ?>><?php _e('Survey', 'ARForms') ?></option>
                                                           
                            </select>
                        </div>
                	</div>
                </div>
             </div>
                
            <?php	  break;
			
			case 'starrange':
			?>
				<div style="float:left;">
             		<div class="fieldoptions_label_style"><?php _e('Range', 'ARForms') ?>:</div>
                    <div class="fieldoptions_field_style">
                         <div style="float:left"><div style="float:left;"><input type="text" class="txtstandardnew" name="field_options[maxnum_<?php echo $field['id'] ?>]" value="<?php echo $field['maxnum']; ?>"  style="width:180px;" /></div>
                         <input type="hidden" class="txtstandardnew" name="field_options[minnum_<?php echo $field['id'] ?>]" value="<?php echo $field['minnum']; ?>" />
                         </div>
                    </div>
             </div>
                
            <?php	  break;
			
			case 'starstyle':
			$field['star_color'] = $field['star_color'] ? $field['star_color'] : 'yellow';
			?>
				<div style="float:left;">	
             		<div class="fieldoptions_label_style"><?php _e('Style', 'ARForms') ?>:</div>
                    <div class="fieldoptions_field_style">
                         <div style="float:left">
                         		<div class="sltstandard" style="float:left;">
                                   <select id="field_options[star_color_<?php echo $field['id'] ?>]" name="field_options[star_color_<?php echo $field['id'] ?>]" style="width:180px;" data-width="180px" onchange="ShowCurrentStar('<?php echo $field['id'] ?>');">
                        
                                    <option value="yellow" <?php selected($field['star_color'], 'yellow') ?>>Yellow</option>
                        
                                    <option value="red" <?php selected($field['star_color'], 'red') ?>>Red</option>
                                    
                                    <option value="orange" <?php selected($field['star_color'], 'orange') ?>>Orange</option>
                                    
                                    <option value="blue" <?php selected($field['star_color'], 'blue') ?>>Blue</option>
                                    
                                    <option value="green" <?php selected($field['star_color'], 'green') ?>>Green</option>
                                    
                                    <option value="black" <?php selected($field['star_color'], 'black') ?>>Black</option>
                                        
                                	</select>
                                    
                                    </div>
                         </div>
                    </div>
             </div>
                
            <?php	  break;
			
			case 'starsize':
			$field['star_size'] = $field['star_size'] ? $field['star_size'] : 'small';
			?>
				<div style="float:left;">	
             		<div class="fieldoptions_label_style"><?php _e('Size', 'ARForms') ?>:</div>
                    <div class="fieldoptions_field_style">
                         <div style="float:left">
                         		<div class="sltstandard" style="float:left;">
                                   <select id="field_options[star_size_<?php echo $field['id'] ?>]" name="field_options[star_size_<?php echo $field['id'] ?>]" style="width:80px;" data-width="80px" onchange="ShowCurrentStar('<?php echo $field['id'] ?>');">
                        
                                    <option value="big" <?php selected($field['star_size'], 'big') ?>>Big</option>
                        
                                    <option value="small" <?php selected($field['star_size'], 'small') ?>>Small</option>
                                        
                                	</select></div>
                                    <?php 
									$small_val = "";
									if(@$field['star_size']=="small") {
										$small_val = "_small"; 
									} 
									?>
                                    <div id="showlivestar_<?php echo $field['id'] ?>" style="float:left;padding-left:10px;margin-top:-2px;">
                                    	<span class="star_1 ratings_stars ratings_stars_<?php echo $field['star_color'].$small_val;?> ratings_over_<?php echo $field['star_color'].$small_val; ?>" data-color="" data-val="1"></span>
                                    </div>
                         </div>
                    </div>
             </div>
                
            <?php	  break;
			
			case 'likebtntitle':
			?>
    
			<div style="float:left;">
             		<div class="fieldoptions_label_style"><?php _e('Like Title', 'ARForms') ?>:</div>
                    <div class="fieldoptions_field_style">
                         <div style="float:left"><div style="float:left;"><input type="text" class="txtstandardnew" name="field_options[lbllike_<?php echo $field['id'] ?>]" value="<?php echo $like_label; ?>"  style="width:180px;" /></div>
                         </div>
                    </div>
             </div>
                
            <?php	  break;
			
			case 'dislikebtntitle':
			?>
				
    
			<div style="float:left;">	
             		<div class="fieldoptions_label_style"><?php _e('Dislike Title', 'ARForms') ?>:</div>
                    <div class="fieldoptions_field_style">
                         <div style="float:left">
                         	<input type="text" class="txtstandardnew" name="field_options[lbldislike_<?php echo $field['id'] ?>]" value="<?php echo $dislike_label; ?>"  style="width:160px;" />		
                         </div>
                    </div>
             </div>
                
            <?php	  break;
			
			case 'likebtnactivecolor':
			?>
                
				<div style="float:left;">	
                <div class="fieldoptions_label_style"><?php _e('Active color', 'ARForms') ?>:</div>
                <div class="fieldoptions_field_style">
                <div style="width:60px; font-size:14px; float:left;">
                	
                    <div class="arf_coloroption_sub">
                        <div class="arf_coloroption arfhex" data-fid="like_bg_color_<?php echo $field['id'] ?>" style="background:<?php echo esc_attr($like_bg_color); ?>;"></div>
                        <div class="arf_coloroption_subarrow_bg">
                            <div class="arf_coloroption_subarrow"></div>
                        </div>
                    </div>
                	<input type="hidden" name="field_options[like_bg_color_<?php echo $field['id'] ?>]" id="like_bg_color_<?php echo $field['id'] ?>" class="txtstandardnew hex" value="<?php echo esc_attr($like_bg_color); ?>" style="width:80px;" size="5" /><!--<br />--><span class="howto" style="padding-left:0px;float:left; margin-top: 2px;"><?php _e('Like', 'ARForms') ?></span></div>
                
                <div style="float:left; width:92px; font-size:14px; margin-left:15px;">
                	<div class="arf_coloroption_sub">
                        <div class="arf_coloroption arfhex" data-fid="dislike_bg_color_<?php echo $field['id'] ?>" style="background:<?php echo esc_attr($dislike_bg_color); ?>;"></div>
                        <div class="arf_coloroption_subarrow_bg">
                            <div class="arf_coloroption_subarrow"></div>
                        </div>
                    </div>
               		<input type="hidden" name="field_options[dislike_bg_color_<?php echo $field['id'] ?>]" id="dislike_bg_color_<?php echo $field['id'] ?>" class="txtstandardnew hex" value="<?php echo esc_attr($dislike_bg_color); ?>" style="width:80px;" size="5" /><!--<br />--><div class="howto" style="padding-right:10px; margin-top:2px;"><?php _e('Dislike', 'ARForms') ?></div> </div>
                </div>
        	</div>
                
            <?php	  break;
			
			case 'handletype':
			?>
            	<div style="float:left;">
             		<div class="fieldoptions_label_style"><?php _e('Handle type', 'ARForms') ?>:</div>
                    <div class="fieldoptions_field_style">
                         <div style="float:left">
                         	
                            <div class="sltstandard" style="float:none;">        
                            <select onchange="arf_change_slider_class(<?php echo $field['id'] ?>);" name="field_options[slider_handle_<?php echo $field['id'] ?>]" id="slider_handle_<?php echo $field['id'] ?>" style="width:180px;" data-width="180px" data-size="15">
                                <option value="round" <?php selected($field['slider_handle'], 'round');?>><?php _e('Round', 'ARForms'); ?></option>
                                <option value="square" <?php selected($field['slider_handle'], 'square');?>><?php _e('Square', 'ARForms'); ?></option>
                                <option value="triangle" <?php selected($field['slider_handle'], 'triangle');?>><?php _e('Triangle', 'ARForms'); ?></option>
                            </select>
                            </div>
                            
                         </div>
                    </div>
             </div>
                
            <?php	  break;
			
			case 'numberofsteps':
			?>
            	<div style="float:left;">
             		<div class="fieldoptions_label_style"><?php _e('Step', 'ARForms') ?>:</div>
                    <div class="fieldoptions_field_style">
                         <div style="float:left"><div style="float:left;"><input type="text" class="txtstandardnew" name="field_options[slider_step_<?php echo $field['id'];?>]" value="<?php echo $slider_step; ?>"  style="width:210px;" /></div>
                         </div>
                    </div>
             </div>
                
            <?php	  break;
			
			case 'defaultvalue':
			?>
            	<div style="float:left;">
             		<div class="fieldoptions_label_style"><?php _e('Default value', 'ARForms') ?>:</div>
                    <div class="fieldoptions_field_style">
                         <div style="float:left"><div style="float:left;"><input type="text" class="txtstandardnew" name="field_options[slider_value_<?php echo $field['id'];?>]" value="<?php echo $field['slider_value']; ?>"  style="width:180px;" /></div>
                         </div>
                    </div>
             </div>
                
            <?php	  break;
			
			case 'trackbgcolor':
			?>
            	<div style="float:left;">
             		<div class="fieldoptions_label_style"><?php _e('Track BG color', 'ARForms') ?>:</div>
                    
                    <div class="fieldoptions_field_style">
                    <div style="width:90px; font-size:14px; float:left;">
                    	<div class="arf_coloroption_sub">
                            <div class="arf_coloroption arfhex" data-fid="slider_bg_color_<?php echo $field['id'] ?>" style="background:<?php echo esc_attr($slider_left_bg_color); ?>;"></div>
                            <div class="arf_coloroption_subarrow_bg">
                                <div class="arf_coloroption_subarrow"></div>
                            </div>
                        </div>
                    	<input type="hidden" name="field_options[slider_bg_color_<?php echo $field['id'] ?>]" id="slider_bg_color_<?php echo $field['id'] ?>" class="txtstandardnew hex" value="<?php echo esc_attr($slider_left_bg_color); ?>" style="width:80px;" size="5" /><!--<br />--><span class="howto" style="padding-left:0px;float:left; margin-top: 2px;"><?php _e('Left side', 'ARForms') ?></span></div>
                    
                    <div style="float:left; width:92px; font-size:14px; margin-left:15px;">
                    	<div class="arf_coloroption_sub">
                            <div class="arf_coloroption arfhex" data-fid="slider_bg_color2_<?php echo $field['id'] ?>" style="background:<?php echo esc_attr($slider_right_bg_color); ?>;"></div>
                            <div class="arf_coloroption_subarrow_bg">
                                <div class="arf_coloroption_subarrow"></div>
                            </div>
                        </div>
                        <input type="hidden" name="field_options[slider_bg_color2_<?php echo $field['id'] ?>]" id="slider_bg_color2_<?php echo $field['id'] ?>" class="txtstandardnew hex" value="<?php echo esc_attr($slider_right_bg_color); ?>" style="width:80px;" size="5" /><!--<br />--><div class="howto" style="padding-right:10px; margin-top:2px;"><?php _e('Right side', 'ARForms') ?></div> </div>
                    </div>
             </div>
                
            <?php	  break;
			
			case 'handlecolor':
			?>
            	<div style="float:left;">
                        <div class="fieldoptions_label_style"><?php _e('Handle color', 'ARForms') ?>:</div>
                        <div class="fieldoptions_field_style">
                             <div style="float:left"><div style="float:left;">
                             	<div class="arf_coloroption_sub">
                                    <div class="arf_coloroption arfhex" data-fid="slider_handle_color_<?php echo $field['id'] ?>" style="background:<?php echo $slider_handle_color; ?>;"></div>
                                    <div class="arf_coloroption_subarrow_bg">
                                        <div class="arf_coloroption_subarrow"></div>
                                    </div>
                                </div>
                             	<input type="hidden" class="hex txtstandardnew" name="field_options[slider_handle_color_<?php echo $field['id'];?>]" id="slider_handle_color_<?php echo $field['id'];?>" value="<?php echo $slider_handle_color; ?>"  style="width:100px;" /></div>
                             </div>
                        </div>
                 </div>
                
            <?php	  break;
			
			case 'placeholdertext':
				$field['default_value'] = $field['default_value'] ? $field['default_value'] : '';
			?>
            	<div style="float:left;">
             		<div class="fieldoptions_label_style"><?php _e('Placeholder Text', 'ARForms') ?>:</div>
                    <div class="fieldoptions_field_style">
                         <div style="float:left"><div style="float:left;"><input type="text" class="txtstandardnew" name="field_options[placeholdertext_<?php echo $field['id'];?>]" id="placeholdertext_<?php echo $field['id'];?>" onkeyup="arfchangeplaceholder('<?php echo $field['id'];?>');" value="<?php echo $field['default_value']; ?>"  style="width:185px;" /></div>
                         </div>
                    </div>
             </div>
                
            <?php	  break;
			
			case 'fielddescription':
			?>
            	<div style="float:left;">
             		<div class="fieldoptions_label_style"><?php _e('Field Description', 'ARForms') ?>:</div>
                    <div class="fieldoptions_field_style">
                         <div style="float:left"><div style="float:left;"><input type="text" class="txtstandardnew" name="field_options[description_<?php echo $field['id'];?>]" id="description_<?php echo $field['id'];?>" value="<?php echo $field['description']; ?>" style="width:210px;" /></div>
                         </div>
                    </div>
             </div>
                
            <?php	  break;
			
			case 'labelname':
			?>
            	<div style="float:left;">
             		<div class="fieldoptions_label_style"><?php _e('Label Name', 'ARForms') ?>:</div>
                    <div class="fieldoptions_field_style">
                         <div style="float:left"><div style="float:left;"><input type="text" class="txtstandardnew" name="field_options[name_<?php echo $field['id'];?>]" id="arfname_<?php echo $field['id'];?>" onkeyup="arfchangelabelname('<?php echo $field['id'];?>');" value="<?php echo $field['name']; ?>" style="width:210px;" /></div>
                         </div>
                    </div>
             </div>
                
            <?php	  break;
			
			case 'phone_validation':
			
			$field['phone_validation'] = $field['phone_validation'] ? $field['phone_validation'] : 'international';	
			?>
            	<div style="float:left;">
             		<div class="fieldoptions_label_style"><?php _e('Phone Number Format', 'ARForms') ?>:</div>
                    <div class="fieldoptions_field_style">
                         <div class="sltstandard" style="float:left;">
                         	<select name="field_options[phone_validation_<?php echo $field['id'];?>]" id="phone_validation_<?php echo $field['id'];?>" data-width="185px">
                            	<option value="international" <?php selected('international', $field['phone_validation']);?>>1234567890</option>
                                <option value="custom_validation_1" <?php selected('custom_validation_1', $field['phone_validation']);?>>(123)456 7890</option>
                                <option value="custom_validation_2" <?php selected('custom_validation_2', $field['phone_validation']);?>>(123) 456 7890</option>
                                <option value="custom_validation_3" <?php selected('custom_validation_3', $field['phone_validation']);?>>(123)456-7890</option>
                                <option value="custom_validation_4" <?php selected('custom_validation_4', $field['phone_validation']);?>>(123) 456-7890</option>
								<option value="custom_validation_5" <?php selected('custom_validation_5', $field['phone_validation']);?>>123 456 7890</option>
								<option value="custom_validation_6" <?php selected('custom_validation_6', $field['phone_validation']);?>>123 456-7890</option>
                                <option value="custom_validation_7" <?php selected('custom_validation_7', $field['phone_validation']);?>>123-456-7890</option>                                
                            </select>
                         </div>
                    </div>
             </div>
                
            <?php	  break;
			
			case 'password_strength':
			?>
				<div style="float:left;">
            <div class="fieldoptions_label_style"><?php _e('Password Strength Meter', 'ARForms') ?>:</div>
            <div class="fieldoptions_field_style"><label class="lblswitch"><span>NO&nbsp;</span></label><input type="checkbox" class="js-switch" name="field_options[password_strength_<?php echo $field['id'] ?>]" id="password_strength_<?php echo $field['id'] ?>"  <?php echo (isset($field['password_strength']) and $field['password_strength'])? 'checked="checked"':''; ?> value="1" /><label class="lblswitch"><span>&nbsp;YES</span></label></div>
            </div>
                
            <?php	  break;
			
			case 'confirm_password':
			?>
				<div style="float:left;">
            <div class="fieldoptions_label_style"><?php _e('Confirm Password', 'ARForms') ?>:</div>
            <div class="fieldoptions_field_style"><label class="lblswitch"><span>NO&nbsp;</span></label><input type="checkbox" class="js-switch" name="field_options[confirm_password_<?php echo $field['id'] ?>]" onchange="arfchangeconfirmpassword('<?php echo $field['id'];?>');" id="confirm_password_<?php echo $field['id'] ?>"  <?php echo (isset($field['confirm_password']) and $field['confirm_password'])? 'checked="checked"':''; ?> value="1" /><label class="lblswitch"><span>&nbsp;YES</span></label></div>
            </div>
                
            <?php	  break;
			
			case 'confirm_password_label':
				$field['confirm_password_label'] = ( !isset($field['confirm_password_label']) || empty($field['confirm_password_label']) ) ? __('Confirm Password', 'ARForms') : $field['confirm_password_label'];
			?>
            	<div style="float:left;">
             		<div class="fieldoptions_label_style"><?php _e('Confirm Password Label', 'ARForms') ?>:</div>
                    <div class="fieldoptions_field_style">
                         <div style="float:left"><div style="float:left;"><input type="text" class="txtstandardnew" name="field_options[confirm_password_label_<?php echo $field['id'];?>]" id="confirm_password_label_<?php echo $field['id'];?>" value="<?php echo $field['confirm_password_label']; ?>" style="width:210px;" <?php if( !isset($field['confirm_password']) or !$field['confirm_password'] ) { echo 'disabled="disabled"'; }?> /></div>
                         </div>
                    </div>
             </div>
                
            <?php	  break;
			
			case 'invalid_password':
				$field['invalid_password'] = ( !isset($field['invalid_password']) || empty($field['invalid_password']) ) ? __('Confirm Password does not match with password', 'ARForms') : $field['invalid_password'];
			?>
            	<div style="float:left;">
             		<div class="fieldoptions_label_style"><?php _e('Message for invalid Password', 'ARForms') ?>:</div>
                    <div class="fieldoptions_field_style">
                         <div style="float:left"><div style="float:left;"><input type="text" class="txtstandardnew" name="field_options[invalid_password_<?php echo $field['id'];?>]" id="invalid_password_<?php echo $field['id'];?>" value="<?php echo $field['invalid_password']; ?>" style="width:210px;" <?php if( !isset($field['confirm_password']) or !$field['confirm_password'] ) { echo 'disabled="disabled"'; }?> /></div>
                         </div>
                    </div>
             </div>
                
            <?php	  break;
			
			default:
		}
		
	}
	
	function arf_replace_shortcodes($content='', $entry=0)
	{
		if( ! $entry )
			return $content;
			
		$tagregexp = '';

		preg_match_all("/\[(if )?($tagregexp)\b(.*?)(?:(\/))?\](?:(.+?)\[\/\2\])?/s", $content, $matches, PREG_PATTERN_ORDER);
		
		if( $matches and $matches[3] )
		{
			foreach($matches[3] as $shortcode)
			{
				if( $shortcode )
				{
					global $arffield;
					$display=false;
					$show='one'; 
					$odd='';
					
					$field_ids = explode(':',$shortcode);
					$field_id  = end($field_ids); 
					 	
					$field = $arffield->getOne( $field_id );
			
					if(!isset($field))
						$field = false;
					
					$sep = (isset($atts['sep'])) ? $atts['sep'] : ', ';	
			
					if($field){
			
			
						$field->field_options = maybe_unserialize($field->field_options);
			
			
						$replace_with = arrecordhelper::get_post_or_entry_value($entry, $field);
			
			
						$replace_with = maybe_unserialize($replace_with);
						
						$atts['entry_id'] = $entry->id;


                        $atts['entry_key'] = $entry->entry_key;


                        $atts['attachment_id'] = $entry->attachment_id;


                        $replace_with = apply_filters('arffieldsreplaceshortcodes', $replace_with, $tag, $atts, $field); 


                    if (isset($replace_with) and is_array($replace_with))


                        $replace_with = implode($sep, $replace_with);





                    if ($field and $field->type == 'file'){

                        $size = (isset($atts['size'])) ? $atts['size'] : 'thumbnail';

                        if($size != 'id')

                            $replace_with = arfieldhelper::get_media_from_id($replace_with, $size);

                    }

                    


                        if($field){


                            if (isset($atts['show']) and $atts['show'] == 'field_label'){


                                $replace_with = stripslashes($field->name);


                            }else if (empty($replace_with) and $replace_with != '0'){


                                $replace_with = '';


                                if ($field->type == 'number')


                                    $replace_with = '0';


                            }else{


                                $replace_with = arfieldhelper::get_display_value($replace_with, $field, $atts);


                            }


                        }

                            

                        if (isset($atts['sanitize']))


                            $replace_with = sanitize_title_with_dashes($replace_with);


                            


                        if (isset($atts['sanitize_url']))


                            $replace_with = urlencode(htmlentities($replace_with));



                        if(isset($atts['clickable']))


                            $replace_with = make_clickable($replace_with);


                        if (!isset($replace_with))


                            $replace_with = '';
					
						
						$content = str_replace('['.$shortcode.']', $replace_with, $content);
					}
				}
			}
		}
		
		return $content; 	
	}
	
	function changeoptionorder( $field )
	{
		if( ! $field )
			return;
		
		global $wpdb;
		
		$option_order = @maybe_unserialize( $field['option_order'] ); 
				
		if( $option_order )
		{
			$options = $field['options'];
			$arr2ordered = array();

			foreach ( $option_order as $key) {
    			$arr2ordered[ $key ] = $options[ $key ];					
			}			
			return $arr2ordered;
		}
		else
		 return $field['options'];  
	}
	
	function array_push_after($src,$in,$pos){
		if(is_int($pos)) $R=array_merge(array_slice($src,0,$pos+1), $in, array_slice($src,$pos+1));
		else{
			foreach($src as $k=>$v){
				$R[$k]=$v;
				if($k==$pos)$R=array_merge($R,$in);
			}
		}return $R;
	}
	
	function get_confirm_password_field( $field )
	{
		if( ! $field )
			return;
		
		global $MdlDb, $wpdb;
			
		$key 	= armainhelper::get_unique_key('', $MdlDb->fields, 'field_key');
		$label	= $field['confirm_password_label'];
		$invalid= $field['invalid_password'];
		
		$field['confirm_password_field'] = arfieldhelper::get_actual_id($field['id']);
		$field['id']		= rand(0000000, 9999999);		
		$field['field_key'] = $key;
		$field['name'] 		= $label;
		$field['invalid'] 	= $invalid;		 
		$field['type']		= 'confirm_password';
		$field['required']	= 0;
		$field['password_strenth'] = 0;
		 
		return $field;
	}
}
?>